package za.co.momentum.recurring.client.thread;

import java.util.EventObject;

/**
 * This class represents an EventObject for the ServiceThreadListener.
 * 
 * @author Deon van Aarde 
 * Momentum Risk & Savings Created on 2005/08/30
 */
public class ThreadEvent extends EventObject {
	
	/*
	 * The exception thrown when something bad has happend.
	 */
	private Exception thrown;

	/*
	 * This is the resulting object if there is any.
	 */
	private Object result;

	public ThreadEvent(Object source) {
		super(source);
	}

	public ThreadEvent(Object source, Object threadResult) {
		super(source);
		result = threadResult;
	}

	public ThreadEvent(Object source, Exception threadException) {
		super(source);
		thrown = threadException;
	}

	public Exception getException() {
		return thrown;
	}

	public Object getResult() {
		return result;
	}
}