package za.co.momentum.recurring.client.thread;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * This class will handle all the thread listener calls.
 * 
 * @author Deon van Aarde 
 * Momentum Risk & Savings 
 * Created on 2005/08/30
 * 
 */
public class ThreadListenerHandler {

	ArrayList listeners = new ArrayList();

	Object theListened;

	public ThreadListenerHandler(Object listened) {
		theListened = listened;
	}

	public synchronized void addThreadListener(ThreadListenerIFace aListener) {
		listeners.add(aListener);
	}

	public synchronized void removeThreadListener(ThreadListenerIFace aListener) {
		listeners.remove(aListener);
	}

	public void broadcastResult(Object result) {
		Iterator sendList;
		synchronized (this) {
			sendList = ((ArrayList) listeners.clone()).iterator();
		}
		ThreadEvent broadcastData = new ThreadEvent(theListened, result);
		while (sendList.hasNext()) {
			ThreadListenerIFace aListener = (ThreadListenerIFace) sendList
					.next();
			aListener.threadResult(broadcastData);
		}
	}

	public void broadcastException(Exception anException) {
		Iterator sendList;
		synchronized (this) {
			sendList = ((ArrayList) listeners.clone()).iterator();
		}
		ThreadEvent broadcastData = new ThreadEvent(theListened, anException);
		while (sendList.hasNext()) {
			ThreadListenerIFace aListener = (ThreadListenerIFace) sendList
					.next();
			aListener.threadExceptionThrown(broadcastData);
		}
	}
}
