package za.co.momentum.recurring.nurse.client.model;

import org.apache.log4j.Logger;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;

public class ClientSecurityManager {
	
	private static final Logger LOG = Logger
	.getLogger(ClientSecurityManager.class);
	private static ClientSecurityManager instance;
	private UserTO user;
	private UserTO loggedInUser;
	private boolean dcRole;
	private boolean adminRole;
	private boolean nurseRole;
	private RoleTO[] roles;
	
	public static final int NURSE_ROLE = 1;
	public static final int DC_ROLE = 2;
	public static final int ADMIN_ROLE = 3;

	public RoleTO[] getRoles() {
		return roles;
	}

	public UserTO getUser() {
		return user;
	}

	public void setUser(UserTO user) {
		LOG.info("Setting user and roles in ClientSecurityManager");
		this.user = user;
		nurseRole = false;
		dcRole = false;
		adminRole = false;
		if (user.getRoles() == null) {
			LOG.info("Roles is null");
			return;
		}
		roles = user.getRoles();
		LOG.info("Role length=" + roles.length);
		
		for (int i = 0; i < user.getRoles().length; i++) {
			if (roles[i].getRoleType() == NURSE_ROLE) {
				nurseRole = true;
			}
			if (roles[i].getRoleType() == DC_ROLE) {
				dcRole = true;
			}
			if (roles[i].getRoleType() == ADMIN_ROLE) {
				adminRole = true;
			}
		}
		LOG.info("Done setting the user with roles");
	}
	
	public UserTO getLoggedInUser() {
		return loggedInUser;
	}

	public void setLoggedInUser(UserTO loggedInUser) {
		this.loggedInUser = loggedInUser;
	}

	public boolean isDCRole() {
		return dcRole;
	}

	public boolean isNurseRole() {
		return nurseRole;
	}

	public boolean isAdminRole() {
		return adminRole;
	}
	
	public static ClientSecurityManager getInstance() {

		if (instance == null) {
			synchronized (ClientSecurityManager.class) {
				if (instance == null) {
					instance = new ClientSecurityManager();
				}
			}
		}
		return instance;
	}
}
