package za.co.momentum.recurring.nurse.client.model;

import java.util.HashMap;
import org.apache.log4j.Logger;
import za.co.momentum.recurring.nurse.client.ui.ErrorDialog;

/**
 * This class is responsible for displaying the error messages to the screen.
 * 
 * @author NideBruyn
 * Created on 09 Nov, 2005.
 */
public class ErrorMessages {
	private static final Logger LOG = Logger.getLogger(ErrorMessages.class);
	private static HashMap errorCodes;
	public static final String M0 = "m0";
	public static final String M1 = "m1";
	public static final String M2 = "m2";
	public static final String M3 = "m3";
	public static final String M4 = "m4";
	public static final String M5 = "m5";
	public static final String M6 = "m6";
	public static final String M7 = "m7";
	public static final String M8 = "m8";
	public static final String M9 = "m9";
	public static final String M10 = "m10";
	public static final String M11 = "m11";
	public static final String M12 = "m12";
	public static final String M13 = "m13";
	public static final String M14 = "m14";
	public static final String M15 = "m15";
	public static final String M16 = "m16";
	public static final String M17 = "m17";
	public static final String M18 = "m18";
	public static final String M19 = "m19";
	public static final String M20 = "m20";
	public static final String M21 = "m21";
	public static final String MOK = "ok";
	public static final String RESTART = "restart";
	public static final String M22 = "m22";
	public static final String M23 = "m23";
	public static final String M24 = "m24";
	public static final String M25 = "m25";

	public static void main(String[] args) {

		String[] param = new String[2];
		param[0] = "11";
		param[1] = "20";
		ErrorMessages.showMessage(M5, param);
	}

	private static void initialize() {

		errorCodes = new HashMap();
		errorCodes.put(M0, "A technical Error has occured");
		errorCodes.put(M1, "Duplicate type: %s");
		errorCodes.put(M2, "Type not found");
		errorCodes.put(M3, "Attribute is Mandatory '%s'");
		errorCodes.put(M4, "Attribute must be a valid type");
		errorCodes.put(M5, "Attribute length must be between %s and %s");
		errorCodes.put(M6, "Incorrect Username or Password. Access Denied.");
		errorCodes.put(M7, "Incorrect Password. Access Denied.");
		errorCodes.put(M8, "Are you sure you want to logout?");
		errorCodes.put(M9, "Are you sure you want to exit?");
		errorCodes.put(M10, "%s ");
		errorCodes.put(M11, "Are you sure you want to close this window?");
		errorCodes.put(M12, "Nothing found with the specified criteria");
		errorCodes.put(M13, "Diary has changed and time already booked out");
		errorCodes.put(M14, "Any additional test done?");
		errorCodes.put(M15, "Do you want to Reschedule?");
		errorCodes.put(M16, "Username or password cannot be empty");
		errorCodes.put(M17, "Please close all sub windows before %s");
		errorCodes.put(M18, "Date must be in the future");
		errorCodes.put(M19, "Timeslot allready booked.  Please select another timeslot");
		errorCodes.put(M20, "The ToDate must be after the FromDate");
		errorCodes.put(M21, "Could not connect to server. Please check connection.\nIf using a Edge card please make sure it is inserted properly and connected.");
		errorCodes.put(M22, "Error occured during retrieval of resourse files.");
		errorCodes.put(M23, "Invalid search criteria");
		errorCodes.put(M24, "Your session has expired. Please make sure you are online to login.");
		errorCodes.put(MOK, "Action completed successfully");
		errorCodes.put(RESTART, "Upgrade succesfull.  Will restart application for changes to take effect.");
		errorCodes.put(M25, "You are not authorized to use this app. Please contact the system administrator.");
	}

	public static void showMessage(String messageNumber) {

		if (errorCodes == null) {
			initialize();
		}
		ErrorDialog err = new ErrorDialog();
		try {
			err.setText((String) errorCodes.get(messageNumber));
		} catch (Exception e) {
			err.setText("Unknown error message");
		}
		err.setButton1("&OK", true);
		err.setButton2("", false);
		err.open();
	}

	public static void showDialog(String dialogNumber) {

		if (errorCodes == null) {
			initialize();
		}
		ErrorDialog err = new ErrorDialog();
		try {
			err.setText((String) errorCodes.get(dialogNumber));
		} catch (Exception e) {
			err.setText("Unknown error message");
		}
		err.setButton1("&Yes", true);
		err.setButton2("&No", true);
		err.open();
	}

	public static void showMessage(String messageNumber, String[] parameters) {

		if (errorCodes == null) {
			initialize();
		}
		String temp = "";
		try {
			temp = (String) errorCodes.get(messageNumber);
		} catch (Exception e) {
			temp = "Unknown error message";
		}
		if (temp == null) {
			temp = "Unknown error message";
		}
		if (parameters != null) {
			for (int i = 0; i < parameters.length; i++) {
				temp = temp.replaceFirst("%s", parameters[i]);
			}
		}
		ErrorDialog err = new ErrorDialog();
		err.setText(temp);
		err.setButton1("&OK", true);
		err.setButton2("", false);
		err.open();
	}

	public static void showDialog(String dialogNumber, String[] parameters) {

		if (errorCodes == null) {
			initialize();
		}
		String temp = "";
		try {
			temp = (String) errorCodes.get(dialogNumber);
		} catch (Exception e) {
			temp = "Unknown error message";
		}
		if (temp == null) {
			temp = "Unknown error message";
		}
		if (parameters != null) {
			for (int i = 0; i < parameters.length; i++) {
				temp = temp.replaceFirst("%s", parameters[i]);
			}
		}
		LOG.debug("Temp = " + temp);
		ErrorDialog err = new ErrorDialog();
		err.setText(temp);
		err.setButton1("&Yes", true);
		err.setButton2("&No", true);
		err.open();
	}
}
