package za.co.momentum.recurring.nurse.client.model;

import java.util.HashMap;
import java.util.Stack;
import za.co.momentum.recurring.nurse.client.ui.SearchParameters;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;

public class ParameterHolder {
	private static ParameterHolder instance;
	private HashMap parms;
	// DOnt use this for anything but AppReq for the appointments, this is not a
	// general purpose stack!
	private Stack appParams;
	private Stack removeApps;
	private Stack searchParams;
	private Stack todoApps;

	public static ParameterHolder getInstance() {
		if (instance == null) {
			synchronized (ParameterHolder.class) {
				if (instance == null) {
					instance = new ParameterHolder();
				}
			}
		}
		return instance;
	}
	private ParameterHolder() {
		parms = new HashMap();
		appParams = new Stack();
		removeApps = new Stack();
		searchParams = new Stack();
		todoApps = new Stack();
	}
	public Object getParameter(String name) {
		return parms.get(name);
	}
	public void addParameter(String name, Object value) {
		parms.put(name, value);
	}
	public void addAppArgument(AppDetailTO o) {
		appParams.push(o);
	}
	public AppDetailTO getAppArgument() {
		return (AppDetailTO) appParams.pop();
	}
	public void qAppForRemoval(AppDetailTO o) {
		removeApps.push(o);
	}
	public AppDetailTO popAppForRemoval() {
		return (AppDetailTO) removeApps.pop();
	}
	public void pushSearchParams(SearchParameters o) {
		searchParams.push(o);
	}
	public SearchParameters popSearchParams() {
		if (searchParams.size() == 0)
			return null;
		return (SearchParameters) searchParams.pop();
	}
	public void pushTodoApps(AppDetailTO a) {
		todoApps.push(a);
	}
	public AppDetailTO popTodoApps() {
		if (todoApps.size() == 0)
			return null;
		return (AppDetailTO) todoApps.pop();
	}
}
