package za.co.momentum.recurring.nurse.client.model;

/**
 * @author Rudolph Pretorius
 *
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import org.apache.log4j.Logger;

import za.co.momentum.risk.fastlane.nurse.dto.SuburbTO;

public class SuburbUploader {

	private static final Logger LOG = Logger.getLogger(SuburbUploader.class);

	private final String SUBURB_TABLE = "fsuburbpf";

	public static void main(String[] args) {
		SuburbUploader upload = new SuburbUploader("c:/LCRDIAL.ASC");
		//.UploadFileUsingHibernate();
	}

	private String filename;

	private List suburbs;

	public SuburbUploader(String suburbFile) {
		filename = suburbFile;
		suburbs = new ArrayList();
	}

	// Returns a list of SuburbFormat object
	public List getSuburbs() {
		if (parseFile()) {
			return suburbs;
		} else {
			return null;
		}
	}

	/*public boolean UploadFileUsingHibernate() {
		if (parseFile()) {
			try {
				Configuration cfg = new Configuration();
				cfg.setProperty("hibernate.connection.driver_class",
						"org.postgresql.Driver");
				cfg.setProperty("hibernate.connection.url",
						"jdbc:postgresql://10.1.144.50:5432/travelNurse");
				cfg.setProperty("hibernate.connection.username", "postgres");
				cfg.setProperty("hibernate.connection.password", "123456");
				cfg.setProperty("hibernate.dialect",
						"net.sf.hibernate.dialect.PostgreSQLDialect");

				SessionFactory sessions = cfg.buildSessionFactory();
				Session session = sessions.openSession();
				Transaction tx = session.beginTransaction();
				for (Iterator i = suburbs.iterator(); i.hasNext();) {
					SuburbTO s = (SuburbTO) i.next();
					Timestamp timeStamp = new Timestamp(Calendar.getInstance()
							.getTimeInMillis());
					s.setCreateTS(timeStamp);
					SystemService service = new SystemService();
					s.setCreateUser(service.getSystemUserEntity());
					s.setUpdateTS(timeStamp);
					s.setUpdateUser(service.getSystemUserEntity());
					session.saveOrUpdate(s);
				}
				tx.commit();
			} catch (Exception e) {
				LOG.error("Could not do file upload " + e.getMessage());
			}
		}
		return true;
	}*/

	// Write file to db
	/*public boolean UploadFile() {
		if (parseFile()) {
			PostgresqlConnection pc = new PostgresqlConnection();
			Connection con = pc.getConnection();
			try {
				Statement st = con.createStatement();

				// Uncomment line below to clear table
				// st.executeUpdate("delete from " + SUBURB_TABLE + " where
				// 1=1");
				String sqlInsert;
				String sqlUpdate;
				Long userid = new Long(1);

				for (int i = 0; i < suburbs.size(); i++) {
					Timestamp timeStamp = new Timestamp(Calendar.getInstance()
							.getTimeInMillis());
					Suburb sf = (Suburb) suburbs.get(i);
					sqlUpdate = "UPDATE " + SUBURB_TABLE + " SET subName='"
							+ sf.getSuburbName() + "', subcity='"
							+ sf.getCity() + "', subcd='" + sf.getCode()
							+ "', updatets='" + timeStamp + "', updateuserid="
							+ userid;

					sqlInsert = "INSERT INTO "
							+ SUBURB_TABLE
							+ "(subid,subname,subcity,subcd, createts, createuserid ) VALUES("
							+ sf.getId() + ",'" + sf.getSuburbName() + "','"
							+ sf.getCity() + "','" + sf.getCode() + "','"
							+ timeStamp + "'," + userid + ")";

					LOG.debug(sqlInsert);
					try {
						st.execute(sqlInsert);
					} catch (Exception e) {
						if (e.getMessage().indexOf(
								"duplicate key violates unique constraint") > -1) {
							try {
								LOG.debug(sqlUpdate);
								st.addBatch(sqlUpdate);
								// st.execute(sqlUpdate);
							} catch (Exception ex) {
								LOG.warn("Could not excute sql " + sqlUpdate
										+ " " + ex.getMessage());
							}
						} else {
							LOG.warn("Could not excute sql " + sqlInsert + " "
									+ e.getMessage());
						}
					}
				}
				st.executeBatch();
				st.close();
			} catch (SQLException e) {
				LOG.error("Error processing record " + e.getMessage());
				return false;
			}
			try {
				con.close();
			} catch (SQLException e) {
				LOG.error("Could not close connection " + e.getMessage());
			}
		}
		return true;
	}*/

	private boolean recordExists(Statement s, Long key) {
		String sql = "SELECT * FROM " + SUBURB_TABLE + " WHERE subid=" + key;
		try {
			ResultSet res = s.executeQuery(sql);
			if (res.next()) {
				res.close();
				return true;
			} else {
				res.close();
				return false;
			}
		} catch (SQLException e) {
			LOG.error("Execute query error " + sql + " " + e.getMessage());
		}
		return false;
	}

	// Create comma delimited file
	public boolean createCSVformatFile(String CSVFilename) {
		if (parseFile()) {
			try {
				BufferedWriter br = new BufferedWriter(new FileWriter(
						CSVFilename));
				for (int i = 0; i < suburbs.size(); i++) {
					SuburbTO sf = (SuburbTO) suburbs.get(i);
					br.write(sf.getId() + "," + sf.getSuburbName() + ","
							+ sf.getCity() + "," + sf.getCode());
					br.newLine();
				}
				br.flush();
				br.close();
			} catch (IOException e) {
				LOG.error("IO Error filename=" + CSVFilename + " "
						+ e.getMessage());
				return false;
			}
			return true;
		} else {
			return false;
		}

	}

	private boolean parseFile() {
		try {
			BufferedReader br = new BufferedReader(new FileReader(filename));
			String line = null;
			do {
				line = br.readLine();
				if (line != null) {
					StringTokenizer st = new StringTokenizer(line, " ");
					String key = (String) st.nextElement();
					String value = "";
					while (st.hasMoreElements()) {
						value += (String) st.nextElement() + " ";
					}
					try {
						SuburbTO s = new SuburbTO();
						s.setCity(key.substring(8));
						s.setCode(key.substring(0, 4));
						s.setId(new Long(key));
						s.setSuburbName(value);
						suburbs.add(s);
					} catch (Exception ee) {
						LOG.warn("Format error in file " + line + " "
								+ ee.getMessage());
					}
				}
			} while (line != null);
			br.close();
		} catch (FileNotFoundException e) {
			LOG.error("File not found " + filename + " " + e.getMessage());
			return false;
		} catch (IOException e) {
			LOG.error("IOException " + e.getMessage());
			return false;
		}
		return true;

	}

}
