package za.co.momentum.recurring.nurse.client.reports;

import java.io.IOException;
import java.net.URL;


import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;

import za.co.momentum.recurring.nurse.util.TNLogger;

public class DCBookingsReport extends ExcelReport {

	private double totNoAnswer = 0;

	private double totWrongNumber = 0;

	private double totClientDeclined = 0;

	private double totDiarise = 0;

	private double totBookApp = 0;

	private double totManualApp = 0;

	private double totCloseApp = 0;

	private double totReopenApp = 0;

	// private double total = 0;

	public DCBookingsReport(ExcelData data, String filename) {
		super(data, filename);
		try {
			URL furl = Platform.getProduct().getDefiningBundle().getEntry("dcReportTemplate.xls");

			URL lurl = FileLocator.toFileURL(furl);
			templateName = lurl.getPath();
			TNLogger.debug("Template path = " + templateName);
		} catch (IOException e) {
			TNLogger.error("Could not find template dcBookingsTemplate.xls "
					+ e.getMessage());
		}
	}

	protected void writeReport() {
		TNLogger.debug("Entering writeReport");

		HSSFCell c = getCell("$date");
		c.setCellValue(data.getTheDate());

		c = getCell("$startdate");
		c.setCellValue(data.getStartDate());

		c = getCell("$enddate");
		c.setCellValue(data.getEndDate());

		c = getCell("$dc");
		insertDCs(c);

		c = getCell("$totNoAnswer");
		c.setCellValue(totNoAnswer);

		c = getCell("$totWrongNumber");
		c.setCellValue(totWrongNumber);

		c = getCell("$totClientDeclined");
		c.setCellValue(totClientDeclined);

		c = getCell("$totDiarise");
		c.setCellValue(totDiarise);

		c = getCell("$totBookApp");
		c.setCellValue(totBookApp);

		c = getCell("$totManualApp");
		c.setCellValue(totManualApp);

		c = getCell("$totCloseApp");
		c.setCellValue(totCloseApp);

		c = getCell("$totReopenApp");
		c.setCellValue(totReopenApp);

		TNLogger.debug("Finished writing report DCReport");
	}

	private void insertDCs(HSSFCell startCell) {
		HSSFCell temp = startCell;
		HSSFRow row = sheet.getRow(rownum);
		DCReportDetail[] dcr = data.getDCReportDetail();
		for (int i = 0; i < dcr.length; i++) {
			temp = row.createCell((short) 0);
			temp.setCellValue(dcr[i].getName() + " " + dcr[i].getSurname());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_LEFT);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getNoAnswer());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getWrongNumber());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getClientDeclined());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getDiarise());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getBookApp());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getManualApp());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getCloseApp());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			temp = row.createCell((short) (temp.getCellNum() + 1));
			temp.setCellValue(dcr[i].getReopenApp());
			temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

			totNoAnswer += dcr[i].getNoAnswer();
			totWrongNumber += dcr[i].getWrongNumber();
			totClientDeclined += dcr[i].getClientDeclined();
			totDiarise += dcr[i].getDiarise();
			totBookApp += dcr[i].getBookApp();
			totManualApp += dcr[i].getManualApp();
			totCloseApp += dcr[i].getCloseApp();
			totReopenApp += dcr[i].getReopenApp();

			row = sheet.createRow(row.getRowNum() + 1);
		}
		row = sheet.createRow(row.getRowNum() + 1);

		temp = row.createCell((short) 0);
		temp.setCellValue("Totals:");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_LEFT);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totNoAnswer");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totWrongNumber");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totClientDeclined");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totDiarise");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totBookApp");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totManualApp");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totCloseApp");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);

		temp = row.createCell((short) (temp.getCellNum() + 1));
		temp.setCellValue("$totReopenApp");
		temp = setAlignment(temp, HSSFCellStyle.ALIGN_CENTER);
	}

}
