package za.co.momentum.recurring.nurse.client.tools;

import org.apache.log4j.Logger;
import za.co.momentum.recurring.base.Util;
import za.co.momentum.recurring.base.email.EmailClient;
import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;

public class SendErrorEmail {
  private static final Logger LOG = Logger.getLogger(SendErrorEmail.class);

  public static void sendErrorMail(Exception e, String function, String className) {
    
    try {      
      String exceptionStack = Util.getExceptionStackAsString(e);
      
      // If the error is because of connectivity problem, do not send mail!
      if (exceptionStack.indexOf("Possible end of stream encountered") > 0) {
        return;
      }
      
      UserTO user = ClientSecurityManager.getInstance().getUser();
      // EmailClient.getInstance().sendTechnicalAlert(user.getUsername(), function, e);
      EmailClient.getInstance().sendTechnicalAlert(user.getUsername() + " " + function + " " + className,
          exceptionStack);
    } catch (Exception ex) {
      ex.printStackTrace();
      LOG.debug("Exception during sending mail");
    }
  }
}
