/*
 * Created on 2005/08/18
 */
package za.co.momentum.recurring.nurse.client.ui;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import com.swtdesigner.SWTResourceManager;

public class DayView extends Composite {

  private Text calDate;
  private Combo combo;
  private Table table;
  private Calendar date;
  private SWTCalendar calendar;
  private List appointments;
  private UserTO nurse;

  public UserTO getNurse() {
    return nurse;
  }

  public void setNurse(UserTO nurse) {
    this.nurse = nurse;
  }

  public void setAppointments(List apps) {
    appointments = apps;
  }

  public void getAppointments() {

    appointments = UserServiceManager.getInstance().getAppointmentForNurse(nurse);

  }

  /*
   * private AppReqTO getAppointmentInTimeSlot(Date begin, Date end) { AppReqTO
   * app = null;
   * 
   * try { for (Iterator i = appointments.iterator(); i.hasNext();) { AppReqTO
   * temp = (AppReqTO) i.next(); if (begin.before(temp.getStartTS()) &&
   * end.after(temp.getEndTS())) {
   * 
   * app = temp; break; } } } catch (Exception e) { return null; } return app; }
   */

  public Calendar getDate() {
    return date;
  }

  public void setDate(Calendar date) {
    this.date = date;
  }

  public DayView(final Composite parent, int style) {
    super(parent, style);
    appointments = new ArrayList();
    date = Calendar.getInstance();
    final Menu menu = new Menu(this);
    setMenu(menu);
    addControlListener(new ControlAdapter() {
      public void controlResized(ControlEvent e) {
        table.computeSize(parent.getSize().x, parent.getSize().y, true);
      }
    });
    final MenuItem createAppointmentMenuItem = new MenuItem(menu, SWT.NONE);
    createAppointmentMenuItem.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        NewAppointment n = new NewAppointment(parent.getShell());
        n.createContents();
        n.setDate(date.getTime());
        TableItem t[] = table.getSelection();
        n.setTimeSlot(t[0].getData("timeslotTableColumn").toString());
        n.open();
      }
    });
    createAppointmentMenuItem.setText("Create appointment");

    table = new Table(this, SWT.FULL_SELECTION | SWT.BORDER);
    table.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    table.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        TableItem t[] = table.getSelection();
      }
    });
    table.addMouseListener(new MouseAdapter() {
      public void mouseDown(MouseEvent e) {
        if (e.button == 3) {
          TableItem t[] = table.getSelection();
          menu.setVisible(true);
        }
      }
    });
    table.setLinesVisible(true);
    table.setHeaderVisible(true);
    table.setBounds(190, 60, 439, 189);

    final TableColumn timeslotTableColumn = new TableColumn(table, SWT.CENTER);

    timeslotTableColumn.setResizable(false);
    timeslotTableColumn.setWidth(95);
    timeslotTableColumn.setText("TimeSlot");

    final TableColumn discriptionTableColumn = new TableColumn(table, SWT.NONE);
    discriptionTableColumn.setResizable(false);
    discriptionTableColumn.setWidth(320);
    discriptionTableColumn.setText("Discription");

    final SimpleDateFormat formatter = new SimpleDateFormat("MMM dd yyyy");

    combo = new Combo(this, SWT.NONE);
    combo.setItems(new String[] { "half hour slots", "one hour slots" });
    combo.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    combo.addModifyListener(new ModifyListener() {
      public void modifyText(ModifyEvent e) {
        updateView();
      }
    });
    combo.select(0);
    combo.setBounds(475, 30, 155, 25);

    calDate = new Text(this, SWT.READ_ONLY | SWT.BORDER);
    calDate.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    calDate.addModifyListener(new ModifyListener() {
      public void modifyText(ModifyEvent e) {
        updateView();
      }
    });
    calDate.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLUE));
    calDate.setBounds(235, 30, 134, 24);
    calDate.setText(formatter.format(date.getTime()));

    final Label dateLabel = new Label(this, SWT.NONE);
    dateLabel.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    dateLabel.setText("Date");
    dateLabel.setBounds(190, 35, 40, 17);

    final Button nextDayButton = new Button(this, SWT.NONE);
    nextDayButton.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    nextDayButton.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        date.add(Calendar.DAY_OF_YEAR, 1);
        calDate.setText(formatter.format(date.getTime()));
        calendar.setCalendar(date);
        updateView();
      }
    });
    nextDayButton.setText("Next day");
    nextDayButton.setBounds(305, 0, 90, 25);

    final Button nextMonthButton = new Button(this, SWT.NONE);
    nextMonthButton.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    nextMonthButton.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        date.add(Calendar.MONTH, 1);
        calDate.setText(formatter.format(date.getTime()));
        calendar.setCalendar(date);
        updateView();
      }
    });
    nextMonthButton.setText("Next month");
    nextMonthButton.setBounds(540, 0, 90, 25);

    final Button nextWeekButton = new Button(this, SWT.NONE);
    nextWeekButton.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    nextWeekButton.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        date.add(Calendar.WEEK_OF_YEAR, 1);
        calDate.setText(formatter.format(date.getTime()));
        calendar.setCalendar(date);
        updateView();
      }
    });
    nextWeekButton.setText("Next week");
    nextWeekButton.setBounds(425, 0, 90, 25);

    final Button currentDayBtn = new Button(this, SWT.NONE);
    currentDayBtn.setFont(SWTResourceManager.getFont("", 10, SWT.NONE));
    currentDayBtn.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        date = Calendar.getInstance();
        calDate.setText(formatter.format(date.getTime()));
        calendar.setCalendar(date);
        updateView();
      }
    });
    currentDayBtn.setText("Current day");
    currentDayBtn.setBounds(185, 0, 90, 25);

    calendar = new SWTCalendar(this, SWT.NONE);
    calendar.setCalendar(Calendar.getInstance());
    calendar.addSWTCalendarListener(new SWTCalendarListener() {
      public void dateChanged(SWTCalendarEvent calendarEvent) {

        calDate
            .setText(formatter.format(calendarEvent.getCalendar().getTime()));
        date.setTimeInMillis(calendarEvent.getCalendar().getTime().getTime());
        updateView();

      }

    });

    calendar.setBounds(1, 5, 173, 188);

    final Label label = new Label(this, SWT.SEPARATOR);
    label.setBounds(175, 0, 10, 251);

    //
  }

  private void updateView() {
    if (combo.getSelectionIndex() == 1) { // hour slots
      table.removeAll();
      table.clearAll();
      getAppointments();
      for (int i = 6; i <= 23; i++) {
        Calendar beginSlot = Calendar.getInstance();
        beginSlot.setTime(date.getTime());
        Calendar endSlot = Calendar.getInstance();
        endSlot.setTime(date.getTime());
        beginSlot.set(Calendar.HOUR_OF_DAY, i);
        beginSlot.set(Calendar.MINUTE, 0);

        endSlot.set(Calendar.HOUR_OF_DAY, (i + 1));
        endSlot.set(Calendar.MINUTE, 0);

        final TableItem tableItem = new TableItem(table, SWT.NONE);
        tableItem.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        /*
         * AppReqTO temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem.setText(1,
         * temp.getComment()); } else { tableItem.setText(1, ""); }
         */
        // todo Set data to usable info for appointment
        tableItem
            .setData("timeslotTableColumn", (i) + ":00-" + (i + 1) + ":00");
        tableItem.setText(0, (i) + ":00-" + (i + 1) + ":00");
      }
      for (int i = 0; i <= 5; i++) {
        Calendar beginSlot = Calendar.getInstance();
        beginSlot.setTime(date.getTime());
        Calendar endSlot = Calendar.getInstance();
        endSlot.setTime(date.getTime());
        beginSlot.set(Calendar.HOUR_OF_DAY, i);
        beginSlot.set(Calendar.MINUTE, 0);

        endSlot.set(Calendar.HOUR_OF_DAY, (i + 1));
        endSlot.set(Calendar.MINUTE, 0);
        final TableItem tableItem = new TableItem(table, SWT.NONE);
        tableItem.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        /*
         * AppReqTO temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem.setText(1,
         * temp.getComment()); } else { tableItem.setText(1, ""); }
         * tableItem.setText(0, (i) + ":00-" + (i + 1) + ":00"); tableItem
         * .setData("timeslotTableColumn", (i) + ":00-" + (i + 1) + ":00");
         */
      }

    } else if (combo.getSelectionIndex() == 0) { // half hour slots
      table.removeAll();
      table.clearAll();
      getAppointments();
      setFont(SWTResourceManager.getFont("", 10, SWT.NONE));

      for (int i = 6; i <= 23; i++) {
        Calendar beginSlot = Calendar.getInstance();
        beginSlot.setTime(date.getTime());
        Calendar endSlot = Calendar.getInstance();
        endSlot.setTime(date.getTime());
        beginSlot.set(Calendar.HOUR_OF_DAY, i);
        beginSlot.set(Calendar.MINUTE, 0);

        endSlot.set(Calendar.HOUR_OF_DAY, (i));
        endSlot.set(Calendar.MINUTE, 29);

        final TableItem tableItem = new TableItem(table, SWT.NONE);

        tableItem.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        /*
         * AppReqTO temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem.setText(1,
         * temp.getComment()); } else { tableItem.setText(1, ""); }
         */
        tableItem.setText(0, (i) + ":00-" + (i) + ":30");
        tableItem.setData("timeslotTableColumn", " " + (i) + ":00-" + (i)
            + ":30");
        final TableItem tableItem2 = new TableItem(table, SWT.NONE);
        tableItem2.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        beginSlot.add(Calendar.MINUTE, 30);
        endSlot.add(Calendar.MINUTE, 30);

        /*
         * temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem2.setText(1,
         * temp.getComment()); } else { tableItem2.setText(1, ""); }
         */
        tableItem2.setData("timeslotTableColumn", " " + (i) + ":30-" + (i + 1)
            + ":00");
        tableItem2.setText(0, (i) + ":30-" + (i + 1) + ":00");
      }
      for (int i = 0; i <= 5; i++) {
        Calendar beginSlot = Calendar.getInstance();
        beginSlot.setTime(date.getTime());
        Calendar endSlot = Calendar.getInstance();
        endSlot.setTime(date.getTime());
        beginSlot.set(Calendar.HOUR, i);
        beginSlot.set(Calendar.MINUTE, 0);
        endSlot.set(Calendar.HOUR, (i));
        endSlot.set(Calendar.MINUTE, 29);
        final TableItem tableItem = new TableItem(table, SWT.NONE);
        tableItem.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        /*
         * AppReqTO temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem.setText(1,
         * temp.getComment()); } else { tableItem.setText(1, ""); }
         */
        tableItem.setText(0, (i) + ":00-" + (i) + ":30");
        tableItem.setData("timeslotTableColumn", (i) + ":00-" + (i) + ":30");
        final TableItem tableItem2 = new TableItem(table, SWT.NONE);
        tableItem2.setBackground(0, Display.getCurrent().getSystemColor(
            SWT.COLOR_GRAY));
        beginSlot.add(Calendar.MINUTE, 30);
        endSlot.add(Calendar.MINUTE, 30);
        /*
         * temp = getAppointmentInTimeSlot(beginSlot.getTime(),
         * endSlot.getTime()); if (temp != null) { tableItem2.setText(1,
         * temp.getComment()); } else { tableItem2.setText(1, ""); }
         */
        tableItem2.setText(0, (i) + ":30-" + (i + 1) + ":00");
        tableItem2.setData("timeslotTableColumn", (i) + ":30-" + (i + 1)
            + ":00");
      }
    }

  }

  public void dispose() {
    super.dispose();
  }

  protected void checkSubclass() {
  }

}