package za.co.momentum.recurring.nurse.client.ui;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class ErrorDialog {

  private Text errorText;

  private static final Logger LOG = Logger.getLogger(ErrorDialog.class);

  private Button button1;

  private Button button2;

  protected Shell shell;

  private int buttonPressed = 0;

  public ErrorDialog() {
    createContents();
  }

  public int open() {
    Display display = Display.getDefault();
    shell.open();
    shell.layout();

    shell.setLocation((display.getBounds().width / 2)
        - (shell.getBounds().width / 2), (display.getBounds().height / 2)
        - (shell.getBounds().height / 2));

    while (!shell.isDisposed()) {
      if (!display.readAndDispatch())
        display.sleep();
    }
    return buttonPressed;
  }

  protected void createContents() {
    shell = new Shell(SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
    shell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(),
        "icons/logo-m.gif"));
    shell.setSize(334, 154);

    shell.setText(Application.APPLICATION_NAME);

    final Composite TextArea = new Composite(shell, SWT.NONE);
    TextArea.setEnabled(false);
    TextArea.setBounds(7, 10, 267, 78);

    errorText = new Text(TextArea, SWT.READ_ONLY | SWT.WRAP);
    errorText
        .setFont(SWTResourceManager.getFont("", 10, SWT.BOLD | SWT.ITALIC));
    errorText.setEditable(false);
    errorText.setBounds(0, 5, 260, 68);

    final Composite ButtonArea = new Composite(shell, SWT.NONE);
    ButtonArea.setBounds(0, 93, 327, 34);

    button1 = new Button(ButtonArea, SWT.NONE);
    button1.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        buttonPressed = 1;
        shell.close();
      }
    });
    button1.setBounds(235, 5, 86, 23);
    button1.setText("&OK");

    button2 = new Button(ButtonArea, SWT.NONE);
    button2.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        buttonPressed = 2;
        shell.close();
      }
    });
    button2.setText("button");
    button2.setBounds(135, 5, 86, 23);

    final Label label = new Label(shell, SWT.NONE);
    label.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(),
        "icons/alien03.gif"));
    label.setBounds(279, 53, 35, 35);
    //
  }

  public void setText(String text) {
    errorText.setText(text);
  }

  public void setButton1(String text, boolean show) {
    button1.setText(text);
    button1.setVisible(show);
  }

  public void setButton2(String text, boolean show) {
    button2.setText(text);
    button2.setVisible(show);
  }

  public void dispose() {
    shell.dispose();
  }

}
