/*
 * Created on 2005/08/17
 */
package za.co.momentum.recurring.nurse.client.ui;

import java.util.Date;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.osgi.framework.Bundle;

import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.recurring.nurse.client.model.ClientWindowManager;
import za.co.momentum.recurring.nurse.client.model.ErrorMessages;
import za.co.momentum.recurring.nurse.client.model.User;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import za.co.momentum.recurring.nurse.util.ClientProperties;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import za.co.momentum.recurring.nurse.util.DBHelper;
import za.co.momentum.recurring.nurse.util.DateUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation, company or business for any purpose whatever) then
 * you should purchase a license for each developer using Jigloo. Please visit www.cloudgarden.com for details. Use of
 * Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS MACHINE, SO
 * JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class LoginWindow {

    private static final long SESSION_DAYS = 7;

    private Text password;

    private Text username;

    protected Shell shell;

    private boolean startup;

    public static void main(String[] args) {
        try {
            LoginWindow window = new LoginWindow();
            window.open();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setStartup(boolean startup) {
        this.startup = startup;
    }

    public LoginWindow() {
        startup = true;
    }

    public void hide() {
        shell.setVisible(false);
    }

    public void focus() {
        shell.setVisible(true);
        shell.setMinimized(false);
        shell.forceActive();
    }

    public void open() {
        final Display display = Display.getDefault();
        createContents();
        shell.open();
        shell.setLocation(display.getBounds().width / 2 - 150, display.getBounds().height / 2 - 150);
        shell.layout();
        while (!shell.isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }
    }

    protected void createContents() {
        shell = new Shell(SWT.TITLE | SWT.APPLICATION_MODAL | SWT.BORDER);
        shell.setSize(324, 196);
        shell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/logo-m.gif"));
        shell.setSize(320, 184);
        String verInfo = ClientProperties.getInstance().getProperty("fastlane.versionLabel");
        if (verInfo.toUpperCase().contains("PROD")) {
          verInfo = "";
        }
        Bundle bundle = Platform.getProduct().getDefiningBundle();
        verInfo = (verInfo + " " + (String) bundle.getHeaders().get(org.osgi.framework.Constants.BUNDLE_VERSION)).trim();
		
        shell.setText(Application.APPLICATION_NAME + " Login " + verInfo);
        final Label usernameLabel = new Label(shell, SWT.NONE);
        usernameLabel.setText("Username");
        usernameLabel.setBounds(20, 7, 59, 19);
        final Label passwordLabel = new Label(shell, SWT.NONE);
        passwordLabel.setText("Password");
        passwordLabel.setBounds(20, 40, 56, 17);
        username = new Text(shell, SWT.BORDER);
        username.addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if ((e.keyCode == 13) || (e.keyCode == SWT.KEYPAD_CR)) {
                    doLogin();
                }
            }
        });
        username.setBounds(90, 5, 120, 20);
        password = new Text(shell, SWT.PASSWORD | SWT.BORDER);
        password.addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if ((e.keyCode == 13) || (e.keyCode == SWT.KEYPAD_CR)) {
                    doLogin();
                }
            }
        });
        password.setBounds(90, 34, 120, 20);
        final Button loginButton = new Button(shell, SWT.NONE);
        loginButton.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                doLogin();
            }
        });
        loginButton.setFont(SWTResourceManager.getFont("", 10, SWT.BOLD));
        loginButton.setText("Login");
        loginButton.setBounds(20, 65, 73, 25);
        final Label label = new Label(shell, SWT.NONE);
        label.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(), "icons/Headerlogo_mom.jpg"));
        label.setBounds(12, 95, 240, 50);
        final Button cancelButton = new Button(shell, SWT.NONE);
        cancelButton.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                if (!startup) {
                    ClientWindowManager.getInstance().closeMainShell();
                }
                dispose();
            }
        });
        cancelButton.setText("Cancel");
        cancelButton.setBounds(180, 65, 73, 25);
        final Button minimizeButton = new Button(shell, SWT.NONE);
        minimizeButton.setToolTipText("Minimize window");
        minimizeButton.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                shell.setMinimized(true);
            }
        });
        minimizeButton.setText("-");
        minimizeButton.setBounds(245, -1, 20, 16);
        label.redraw();

        loginButton.setSelection(true);

        doActions();
    }

    private void doLogin() {
        Logger.getLogger(LoginWindow.class).info("Pressed log in");
        if (validate()) {
            Logger.getLogger(LoginWindow.class).info("Finished validating");
            if (startup) {
                User user = null;
                UserTO userTO = null;

                if (user == null) {
                    // Call server for login and queue the request for db
                    Logger.getLogger(LoginWindow.class).info("Calling web service to log in.");
                    try {
                        userTO = UserServiceManager.getInstance().logon(username.getText(), password.getText());

                        // If no user returned from web service call it could either be no connection available, or the logon
                        // has failed, try getting logon details from local DB
                        if (userTO == null) {
                            user = DBHelper.getUser(username.getText());

                            // If a user could be found on the local DB, check if the password entered is correct
                            if (user != null) {
                                userTO = user.getUserTO();
                                // Check if the password matches, if not, try the default password so that a user can at least work!
                                if (user.getPassword().equals(password.getText())) {
                                    if (hasSessionExpired(user)) {
                                        ErrorMessages.showMessage(ErrorMessages.M24);
                                        return;
                                    }
                                } else if (!password.getText().equals("MOMentum")) {
                                    return;
                                } else {
                                	ErrorMessages.showMessage(ErrorMessages.M6);
                                }
                            } else {
                                // No user in db, do not add any user details and deny access
                                return;
                            }
                        } else {
                            final UserTO[] selectedUser = new UserTO[1];

                            if (isMedicalPerson(userTO)) {
                                user = new User(userTO);
                                DBHelper.addUser(user);
                            } else if (isDcAdmin(userTO)) {
                                SelectThirdParty thirdParty = new SelectThirdParty(Display.getCurrent().getActiveShell());
                                thirdParty.userSelectedEvent.addFormalObserver(new EventObserver() {
                                    public void notifyFormal(Object usr) {
                                        selectedUser[0] = (UserTO) usr;
                                    }
                                });
                                thirdParty.open();
                                ClientSecurityManager.getInstance().setLoggedInUser(userTO);
                                userTO = selectedUser[0];
                                user = new User(userTO);
                            } else {
                            	ErrorMessages.showMessage(ErrorMessages.M25);
                            }
                        }
                    } catch (Exception e) {
                        Logger.getLogger(LoginWindow.class).info("User not allowed in app: " + e.getMessage());
                    }
                }

                // If the user object is valid, set it on the ClientSecurityManager singleton and return
                if (user != null) {
                    ClientSecurityManager.getInstance().setUser(userTO);
                    Logger.getLogger(LoginWindow.class).info("After setting user on SecurityManger");
                    dispose();
                } else {
                    return;
                }
            } else {
                if (username.getText().equals(ClientSecurityManager.getInstance().getUser().getUsername())
                        && password.getText().equals(ClientSecurityManager.getInstance().getUser().getPassword())) {
                    dispose();
                    ClientWindowManager.getInstance().unlockWindow();
                } else {
                    ErrorMessages.showMessage(ErrorMessages.M6);
                }
            }

            // Could not validate input details, show error message
        } else {
            ErrorMessages.showMessage(ErrorMessages.M16);
        }
    }

    private boolean isMedicalPerson(final UserTO userTo) {
        return "Nurse".equals(userTo.getRoles()[0].getType()) || "Doctor".equals(userTo.getRoles()[0].getType());
    }

    private boolean isDcAdmin(final UserTO userTo) {
        return "Admin".equals(userTo.getRoles()[0].getType());
    }

    private boolean hasSessionExpired(User user) {
    	System.out.println("***************************");
    	
    	System.out.println(DateUtil.calculateDaysBetween(user.getLastLogin(), new Date()));
    	System.out.println(user.getLastLogin());
    	System.out.println(SESSION_DAYS);
    	
    	System.out.println("***************************");
        return DateUtil.calculateDaysBetween(user.getLastLogin(), new Date()) > SESSION_DAYS;
    }

    private void doActions() {
        if (!startup) { // Hide main shell
            username.setText(ClientSecurityManager.getInstance().getUser().getUsername());
            username.setEditable(false);
            ClientWindowManager.getInstance().lockWindow();
            shell.setMinimized(true);
        } else {
            username.setEditable(true);
        }
    }

    private boolean validate() {
        if (username.getText().equalsIgnoreCase("")) {
            return false;
        }
        if (password.getText().equalsIgnoreCase("")) {
          return false;
        }
        return true;
    }

    public void dispose() {
        shell.dispose();
    }
}
