package za.co.momentum.recurring.nurse.client.ui;

import java.util.Iterator;
import java.util.Map;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.part.ViewPart;
import za.co.momentum.recurring.nurse.util.TNLogger;
import za.co.momentum.recurring.nurse.util.WebCall;
import za.co.momentum.recurring.nurse.util.WebCaller;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class OutstandingWebCalls extends ViewPart {
	public static final String ID = "za.co.momentum.recurring.nurse.client.ui.OutstandingWebCalls";

	private Table table;
	private TableColumn tableColumn1;

	public void createPartControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NONE);
		container.setLayout(new FillLayout());
		table = new Table(container, SWT.FULL_SELECTION | SWT.BORDER);
		table.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				doAction();
			}
		});
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		{
			tableColumn1 = new TableColumn(table, SWT.NONE);
			tableColumn1.setText("key");
			tableColumn1.setWidth(1);
			tableColumn1.setResizable(false);
			tableColumn1.setMoveable(true);
		}
		final TableColumn webcallTableColumn = new TableColumn(table, SWT.NONE);
		webcallTableColumn.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				createActions();
			}
		});
		webcallTableColumn.setWidth(294);
		webcallTableColumn.setText("Service queued                    (click to refresh)");
		final TableColumn statusTableColumn = new TableColumn(table, SWT.NONE);
		statusTableColumn.setWidth(100);
		statusTableColumn.setText("Status");

		final TableColumn noOfRetriesTableColumn = new TableColumn(table, SWT.NONE);
		noOfRetriesTableColumn.setWidth(76);
		noOfRetriesTableColumn.setText("No. of retries");

		final TableColumn errorDescriptionTableColumn = new TableColumn(table, SWT.NONE);
		errorDescriptionTableColumn.setWidth(398);
		errorDescriptionTableColumn.setText("Error description");
		//
		createActions();
		initializeToolBar();
		initializeMenu();
	}

	private void createActions() {
		table.clearAll();
		table.setItemCount(0);
		Map calls = WebCaller.getIntance().getCalls();
		for (Iterator iter = calls.keySet().iterator(); iter.hasNext();) {
			Object key = iter.next();
			WebCall el = (WebCall) calls.get(key);
			
			if (el == null) continue;
			//Line below is to only show appointment done descriptions
			if (el.getDescription().indexOf("Appointment done") == -1) continue;
			
			TableItem row = new TableItem(table, SWT.NONE);
			row.setText(0,key.toString());
			row.setText(1,el.getDescription());
			switch (el.getStatus()) {
			case 1:
				row.setText(2, "STATUS_QUEUED");
				break;
			case 2:
				row.setText(2, "STATUS_BUSY");
				break;
			case 3:
				row.setText(2, "STATUS_DONE");
				break;
			case 4:
				row.setText(2, "STATUS_ERROR");
				break;
			case 5:
				row.setText(2, "STATUS_TIMEOUT");
				break;
			default:row.setText(2,"STATUS_UNKNOWN");
				break;
			}
			row.setText(3, String.valueOf(el.getRetryCount()));
			row.setText(4, el.getError());
		}
	}

	private void doAction() {
		TNLogger.debug("Item selected " + table.getSelection()[0].getText());
	}

	private void initializeToolBar() {
		IToolBarManager tbm = getViewSite().getActionBars().getToolBarManager();
	}

	private void initializeMenu() {
		IMenuManager manager = getViewSite().getActionBars().getMenuManager();
	}

	public void setFocus() {
	}
}
