package za.co.momentum.recurring.nurse.client.ui;

import java.io.File;
import java.util.Calendar;
import java.util.Date;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import com.swtdesigner.SWTResourceManager;

import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.recurring.nurse.client.reports.ExcelData;
import za.co.momentum.recurring.nurse.client.reports.NurseAppointmentReport;
import za.co.momentum.recurring.nurse.client.sao.appreq.AppReqServiceManager;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation, company or business for any purpose whatever) then
 * you should purchase a license for each developer using Jigloo. Please visit www.cloudgarden.com for details. Use of
 * Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS MACHINE, SO
 * JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */

public class SchedulePrintView extends ViewPart{

	public static final String ID_VIEW = "za.co.momentum.recurring.nurse.client.ui.SchedulePrintView";
	 Composite appArea;

	  private Composite cmdArea;

	  private Button bExcell;

	  private SWTCalendar calendar;


	public SchedulePrintView() {
		super();
	}

	/*
	   * (non-Javadoc)
	   * 
	   * @see org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	   */
	@Override
	  public void createPartControl(Composite parent) {
	    
	      {
	        GridLayout parentLayout = new GridLayout();
	        parentLayout.makeColumnsEqualWidth = true;
	        parent.setLayout(parentLayout);
	        parent.setSize(1228, 704);
	      }
	      appArea = new Composite(parent, SWT.NULL);
	      GridLayout appAreaLayout = new GridLayout();
	      GridData appAreaLData = new GridData();
	      appAreaLData.horizontalAlignment = GridData.FILL;
	      appAreaLData.verticalAlignment = GridData.FILL;
	      appAreaLData.grabExcessHorizontalSpace = true;
	      appAreaLData.grabExcessVerticalSpace = true;
	      appArea.setLayoutData(appAreaLData);
	      appArea.setLayout(appAreaLayout);
	      {
	        cmdArea = new Composite(appArea, SWT.NONE);
	        GridLayout cmdAreaLayout = new GridLayout();
	        cmdAreaLayout.numColumns = 6;
	        GridData cmdAreaLData = new GridData();
	        cmdAreaLData.horizontalAlignment = GridData.FILL;
	        cmdAreaLData.verticalAlignment = GridData.FILL;
	        cmdAreaLData.grabExcessHorizontalSpace = true;
	        cmdArea.setLayoutData(cmdAreaLData);
	        cmdArea.setLayout(cmdAreaLayout);
	        {
	          calendar = new SWTCalendar(cmdArea, SWT.NONE);
	          calendar.setCalendar(Calendar.getInstance());
	          GridData calendarLData = new GridData();
	          calendar.setLayoutData(calendarLData);
	          calendar.setBounds(11, 15, 245, 143);
	        }
	      }
	      
	     
	    calendar.getCalendar().setTime(new Date());
	    {
	      bExcell = new Button(cmdArea, SWT.PUSH | SWT.CENTER);
	      GridData bExcellLData = new GridData();
	      bExcellLData.widthHint = 151;
	      bExcellLData.heightHint = 26;
	      bExcellLData.verticalAlignment = GridData.END;
	      bExcell.setLayoutData(bExcellLData);
	      bExcell.setText("Save Diary to Excel");
	      bExcell.setFont(SWTResourceManager.getFont("Tahoma", 8, 1, false, false));
	      bExcell.addSelectionListener(new SelectionAdapter() {
	        public void widgetSelected(SelectionEvent evt) {
	          exportToExcell(evt);
	        }
	      });
	    }
	    calendar.getCalendar().roll(Calendar.DAY_OF_MONTH, true);
	  }

	  @Override
	  public void dispose() {
	    super.dispose();
	  }
      
	  @Override
		public void setFocus() {
			
		}

	  private void exportToExcell(SelectionEvent evt) {
	   
	   RoleTO [] narry = ClientSecurityManager.getInstance().getUser().getRoles();
	   
	    RoleTO nurse = narry[0];
	    
	    AppDetailTO[] ato = AppReqServiceManager.getInstance().getAppreqsByDate(nurse, calendar.getCalendar());
        
	    try {
	      FileDialog fileSaver = new FileDialog(Display.getCurrent().getActiveShell(), SWT.SAVE);

	      fileSaver.setText("Please select a location and enter a file name");
	      fileSaver.setFilterExtensions(new String[] { "*.xls" });
	      fileSaver.setFilterNames(new String[] { "Excel Files" + " (xls)" });

	      fileSaver.open();
	      String fn = fileSaver.getFileName();
	      if (fn.isEmpty()) {
	        return;
	      }
	      if (!fn.endsWith(".xls")) {
	        fn = fn + ".xls";
	      }
	      String dir = fileSaver.getFilterPath();
	      fn = dir + File.separator + fn;
	      if (fn != null & fn.length() > 0) {
	        try {
	          ExcelData ex = new ExcelData(ato);
	          
	          NurseAppointmentReport rep = new NurseAppointmentReport(ex, fn, "Appointments for "
	              + nurse.getUser().getFirstName() + " " + nurse.getUser().getSurname() + " "
	              + calendar.getCalendar().getTime());
	          
	         
	          rep.writeExcellFile();

	          MessageDialog.openInformation(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
	              "Save MedPerson Diary", "Diary saved successfully to Excel File:\n" + fn);

	        } catch (Exception e) {
	          e.printStackTrace();
	        }
	      }
	    } catch (Exception e) {
	      e.printStackTrace();
	    }
	  }

	
	}
