package za.co.momentum.recurring.nurse.client.ui;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.client.TNPlugin.RCPTNPlugin;
import za.co.momentum.recurring.nurse.client.model.ErrorMessages;
import za.co.momentum.recurring.nurse.client.sao.user.UserServiceManager;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import com.swtdesigner.ResourceManager;

public class SelectUser extends TitleAreaDialog {
	private Table table;
	private Text searchSurname;
	private Text searchFirstname;
	private UserTO user;
	private UserTO[] users;

	private void addUsers(UserTO[] users) {
		if (users == null) {
			return;
		}
		for (int i = 0; i < users.length; i++) {
			TableItem tableItem = new TableItem(table, SWT.NONE);
			tableItem.setText(2, users[i].getSurname());
			tableItem.setText(1, users[i].getFirstName());
			tableItem.setText(0, users[i].getUsername());
		}
	}

	public SelectUser(Shell parentShell) {
		super(parentShell);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		final Composite composite = new Composite(container, SWT.NONE);
		composite.setBounds(1, 1, 491, 68);
		final Label firstNameLabel = new Label(composite, SWT.NONE);
		firstNameLabel.setText("Firstname");
		firstNameLabel.setBounds(5, 5, 56, 24);
		final Label surnameLabel = new Label(composite, SWT.NONE);
		surnameLabel.setText("Surname");
		surnameLabel.setBounds(5, 35, 48, 30);
		searchFirstname = new Text(composite, SWT.BORDER);
		searchFirstname.setText("*");
		searchFirstname.setBounds(65, 5, 320, 25);
		searchSurname = new Text(composite, SWT.BORDER);
		searchSurname.setText("*");
		searchSurname.setBounds(65, 35, 320, 25);
		final Button searchButton = new Button(composite, SWT.NONE);
		searchButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				doSearch();
			}
		});
		searchButton.setText("&Search");
		searchButton.setBounds(410, 35, 60, 25);
		composite.setTabList(new Control[] { searchFirstname, searchSurname });
		table = new Table(container, SWT.FULL_SELECTION | SWT.BORDER);
		table.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				buttonPressed(IDialogConstants.OK_ID);
			}
		});
		table.setBounds(5, 70, 482, 157);
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		final TableColumn username = new TableColumn(table, SWT.NONE);
		username.setWidth(108);
		username.setText("Username");
		final TableColumn firstname = new TableColumn(table, SWT.NONE);
		firstname.setWidth(151);
		firstname.setText("Firstname");
		final TableColumn surname = new TableColumn(table, SWT.NONE);
		surname.setWidth(188);
		surname.setText("Surname");
		setTitle("Enter search criteria to search for system users");
		setMessage("Wild card charater is allowed (*)");
		//
		UserServiceManager.getInstance().setTempUser(null);
		return area;
	}

	private void doSearch() {
		if (searchFirstname.getText().equals("")
				&& searchSurname.getText().equals("")) {
			ErrorMessages.showMessage(ErrorMessages.M23);
		} else {
			table.removeAll();
			users = UserServiceManager.getInstance().getUsers(
					searchFirstname.getText(), searchSurname.getText());
			addUsers(users);
		}
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
				true);
		createButton(parent, IDialogConstants.CANCEL_ID,
				IDialogConstants.CANCEL_LABEL, false);
	}

	protected Point getInitialSize() {
		return new Point(500, 375);
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Select user");
		newShell.setImage(ResourceManager.getPluginImage(RCPTNPlugin.getDefault(),
				"icons/images.jpg"));
	}

	protected void buttonPressed(int buttonId) {
		if (buttonId == IDialogConstants.CANCEL_ID) {
			user = null;
			UserServiceManager.getInstance().setTempUser(user);
			close();
			return;
		}
		if (buttonId == IDialogConstants.OK_ID) {
			TableItem[] selected = table.getSelection();
			UserTO user = null;
			for (int i = 0; i < users.length; i++) {
				if (users[i].getUsername().equals(selected[0].getText(0))) {
					user = users[i];
					break;
				}
			}
			UserServiceManager.getInstance().setTempUser(user);
			close();
			return;
		}
		super.buttonPressed(buttonId);
	}
}
