/*
 * Created on 2005/08/16
 */
package za.co.momentum.recurring.nurse.client.ui;

import java.util.Iterator;
import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.nurse.client.sao.suburb.SuburbServiceManager;
import za.co.momentum.risk.fastlane.nurse.dto.SuburbTO;
import com.swtdesigner.SWTResourceManager;

public class ViewWindow implements WindowIFace {
	private static final Logger LOG = Logger.getLogger(ViewWindow.class);
	private Text workTelephoneNumber;
	private Text cellNumber;
	private Text homeTelephoneNumber;
	private Text additionalRequirements;
	private Text broker;
	private Text diaryCoordinator;
	private Text nurse;
	private Text appointmentLocation;
	private Combo suburb;
	private Text addressLine2;
	private Text addressLine1;
	private List testsToBeDone;
	private Table table_3;
	private Table table_2;
	private Text comments;
	private Text appointmentDateTime;
	private Text idNumber;
	private Text language;
	private Table table;
	protected Shell shell;
	private Menu menu;
	private MenuItem noAnswer;
	private MenuItem wrongNumber;
	private MenuItem clientDeclined;
	private MenuItem diarize;
	private MenuItem bookAppointment;
	private MenuItem updateDetails;

	public static void main(String[] args) {
		try {
			ViewWindow window = new ViewWindow();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void focus() {
		shell.setVisible(true);
		shell.setMinimized(false);
		shell.forceActive();
	}

	public void hide() {
		shell.setVisible(false);
	}

	public void open() {
		final Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	protected void createContents() {
		shell = new Shell(SWT.DIALOG_TRIM | SWT.MIN | SWT.MAX);
		shell.setImage(SWTResourceManager.getImage(ViewWindow.class,
				"/icons/logo-m.gif"));
		shell.setSize(770, 577);
		shell.setText("View");
		final TabFolder tabFolder = new TabFolder(shell, SWT.NONE);
		tabFolder.setBounds(2, 2, 751, 234);
		final TabItem newTabItem = new TabItem(tabFolder, SWT.NONE);
		newTabItem.setText("To be scheduled");
		table = new Table(tabFolder, SWT.FULL_SELECTION | SWT.BORDER);
		table.addMouseListener(new MouseAdapter() {
			public void mouseDown(MouseEvent e) {
				if ((e.button == 3) && (table.getSelectionCount() > 0)) {
					menu.setLocation(e.display.getCursorLocation());
					menu.setVisible(true);
				} else {
					menu.setVisible(false);
				}
			}
		});
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		newTabItem.setControl(table);
		final TableColumn lifeAssuredTableColumn = new TableColumn(table, SWT.NONE);
		lifeAssuredTableColumn.setWidth(186);
		lifeAssuredTableColumn.setText("Life assured");
		final TableColumn dateOfBirthTableColumn = new TableColumn(table, SWT.NONE);
		dateOfBirthTableColumn.setWidth(100);
		dateOfBirthTableColumn.setText("Date of birth");
		final TableColumn policyNumberTableColumn = new TableColumn(table, SWT.NONE);
		policyNumberTableColumn.setWidth(100);
		policyNumberTableColumn.setText("Policy number");
		final TableColumn actionTableColumn = new TableColumn(table, SWT.NONE);
		actionTableColumn.setWidth(100);
		actionTableColumn.setText("Action");
		final TableColumn branchTableColumn = new TableColumn(table, SWT.NONE);
		branchTableColumn.setWidth(119);
		branchTableColumn.setText("Branch");
		final TableColumn dateIcodeSetTableColumn = new TableColumn(table, SWT.NONE);
		dateIcodeSetTableColumn.setWidth(100);
		dateIcodeSetTableColumn.setText("Date I-code set");
		final TableItem tableItem = new TableItem(table, SWT.NONE);
		tableItem.setText("New item");
		final TableItem tableItem_1 = new TableItem(table, SWT.NONE);
		tableItem_1.setText("New item");
		final TabItem pendingTabItem = new TabItem(tabFolder, SWT.NONE);
		pendingTabItem.setText("Pending");
		table_2 = new Table(tabFolder, SWT.FULL_SELECTION | SWT.BORDER);
		table_2.setLinesVisible(true);
		table_2.setHeaderVisible(true);
		pendingTabItem.setControl(table_2);
		final TableColumn lifeAssuredTableColumn_1 = new TableColumn(table_2,
				SWT.NONE);
		lifeAssuredTableColumn_1.setWidth(186);
		lifeAssuredTableColumn_1.setText("Life assured");
		final TableColumn dateOfBirthTableColumn_1 = new TableColumn(table_2,
				SWT.NONE);
		dateOfBirthTableColumn_1.setWidth(100);
		dateOfBirthTableColumn_1.setText("Date of birth");
		final TableColumn policyNumberTableColumn_1 = new TableColumn(table_2,
				SWT.NONE);
		policyNumberTableColumn_1.setWidth(100);
		policyNumberTableColumn_1.setText("Policy number");
		final TableColumn actionTableColumn_1 = new TableColumn(table_2, SWT.NONE);
		actionTableColumn_1.setWidth(100);
		actionTableColumn_1.setText("Action");
		final TableColumn branchTableColumn_1 = new TableColumn(table_2, SWT.NONE);
		branchTableColumn_1.setWidth(119);
		branchTableColumn_1.setText("Branch");
		final TableColumn dateIcodeSetTableColumn_1 = new TableColumn(table_2,
				SWT.NONE);
		dateIcodeSetTableColumn_1.setWidth(100);
		dateIcodeSetTableColumn_1.setText("Date I-code set");
		final TabItem completeTabItem = new TabItem(tabFolder, SWT.NONE);
		completeTabItem.setText("Completed");
		table_3 = new Table(tabFolder, SWT.FULL_SELECTION | SWT.BORDER);
		table_3.setLinesVisible(true);
		table_3.setHeaderVisible(true);
		completeTabItem.setControl(table_3);
		final TableColumn lifeAssuredTableColumn_2 = new TableColumn(table_3,
				SWT.NONE);
		lifeAssuredTableColumn_2.setWidth(186);
		lifeAssuredTableColumn_2.setText("Life assured");
		final TableColumn dateOfBirthTableColumn_2 = new TableColumn(table_3,
				SWT.NONE);
		dateOfBirthTableColumn_2.setWidth(100);
		dateOfBirthTableColumn_2.setText("Date of birth");
		final TableColumn policyNumberTableColumn_2 = new TableColumn(table_3,
				SWT.NONE);
		policyNumberTableColumn_2.setWidth(100);
		policyNumberTableColumn_2.setText("Policy number");
		final TableColumn actionTableColumn_2 = new TableColumn(table_3, SWT.NONE);
		actionTableColumn_2.setWidth(100);
		actionTableColumn_2.setText("Action");
		final TableColumn branchTableColumn_2 = new TableColumn(table_3, SWT.NONE);
		branchTableColumn_2.setWidth(119);
		branchTableColumn_2.setText("Branch");
		final TableColumn dateIcodeSetTableColumn_2 = new TableColumn(table_3,
				SWT.NONE);
		dateIcodeSetTableColumn_2.setWidth(100);
		dateIcodeSetTableColumn_2.setText("Date I-code set");
		final Group group = new Group(shell, SWT.NONE);
		group.setBounds(4, 245, 752, 300);
		final Label languageLabel = new Label(group, SWT.NONE);
		languageLabel.setText("Language:");
		languageLabel.setBounds(6, 21, 56, 16);
		final Label idpassportNumberLabel = new Label(group, SWT.NONE);
		idpassportNumberLabel.setText("Id/Passport number:");
		idpassportNumberLabel.setBounds(5, 42, 103, 15);
		final Label preferredAddressLabel = new Label(group, SWT.NONE);
		preferredAddressLabel.setText("Preferred address:");
		preferredAddressLabel.setBounds(8, 63, 99, 16);
		final Label companyNameLabel = new Label(group, SWT.NONE);
		companyNameLabel.setText("Suburb:");
		companyNameLabel.setBounds(10, 107, 85, 17);
		final Label brokerNameLabel = new Label(group, SWT.NONE);
		brokerNameLabel.setText("Broker name:");
		brokerNameLabel.setBounds(4, 274, 66, 15);
		final Label telephoneNumberLabel = new Label(group, SWT.NONE);
		telephoneNumberLabel.setText("Telephone numbers:");
		telephoneNumberLabel.setBounds(375, 147, 98, 17);
		final Label hLabel = new Label(group, SWT.NONE);
		hLabel.setText("(H)");
		hLabel.setBounds(476, 147, 22, 16);
		final Label wLabel = new Label(group, SWT.NONE);
		wLabel.setText("(W)");
		wLabel.setBounds(476, 170, 24, 14);
		final Label cLabel = new Label(group, SWT.NONE);
		cLabel.setText("(C)");
		cLabel.setBounds(476, 193, 19, 15);
		final Label appointmentDateLabel = new Label(group, SWT.WRAP);
		appointmentDateLabel.setText("Appointment date and time:");
		appointmentDateLabel.setBounds(5, 203, 91, 29);
		final Label testsToBeLabel = new Label(group, SWT.NONE);
		testsToBeLabel.setText("Tests to be done:");
		testsToBeLabel.setBounds(375, 18, 120, 17);
		final Label nurseLabel = new Label(group, SWT.NONE);
		nurseLabel.setText("Nurse:");
		nurseLabel.setBounds(6, 229, 83, 16);
		final Label commentsLabel = new Label(group, SWT.NONE);
		commentsLabel.setText("Comments:");
		commentsLabel.setBounds(375, 216, 80, 17);
		final Label diaryCoordinatorUseridLabel = new Label(group, SWT.NONE);
		diaryCoordinatorUseridLabel.setText("Diary coordinator:");
		diaryCoordinatorUseridLabel.setBounds(5, 252, 91, 15);
		language = new Text(group, SWT.BORDER);
		language.setBounds(110, 17, 238, 20);
		idNumber = new Text(group, SWT.BORDER);
		idNumber.setBounds(110, 39, 238, 18);
		appointmentDateTime = new Text(group, SWT.BORDER);
		appointmentDateTime.setBounds(110, 203, 238, 20);
		comments = new Text(group, SWT.V_SCROLL | SWT.BORDER | SWT.WRAP);
		comments.setBounds(500, 216, 243, 75);
		testsToBeDone = new List(group, SWT.V_SCROLL | SWT.BORDER | SWT.H_SCROLL);
		testsToBeDone.setBounds(500, 18, 243, 75);
		addressLine1 = new Text(group, SWT.BORDER);
		addressLine1.setBounds(110, 59, 238, 20);
		addressLine2 = new Text(group, SWT.BORDER);
		addressLine2.setBounds(110, 81, 238, 20);
		suburb = new Combo(group, SWT.NONE);
		suburb.select(1);
		suburb.setBounds(110, 103, 238, 21);
		final Label appointmentLocationLabel = new Label(group, SWT.WRAP);
		appointmentLocationLabel.setText("Appointment location:");
		appointmentLocationLabel.setBounds(9, 141, 86, 44);
		appointmentLocation = new Text(group, SWT.V_SCROLL | SWT.BORDER | SWT.WRAP);
		appointmentLocation.setBounds(110, 126, 238, 75);
		nurse = new Text(group, SWT.BORDER);
		nurse.setBounds(110, 225, 238, 20);
		diaryCoordinator = new Text(group, SWT.BORDER);
		diaryCoordinator.setBounds(110, 247, 238, 20);
		broker = new Text(group, SWT.BORDER);
		broker.setBounds(110, 269, 238, 20);
		final Label additionalRequirementsLabel = new Label(group, SWT.WRAP);
		additionalRequirementsLabel.setText("Additional requirements:");
		additionalRequirementsLabel.setBounds(375, 96, 120, 30);
		additionalRequirements = new Text(group, SWT.V_SCROLL | SWT.BORDER
				| SWT.WRAP);
		additionalRequirements.setBounds(500, 96, 243, 48);
		homeTelephoneNumber = new Text(group, SWT.BORDER);
		homeTelephoneNumber.setBounds(500, 147, 243, 20);
		cellNumber = new Text(group, SWT.BORDER);
		cellNumber.setBounds(500, 193, 243, 20);
		workTelephoneNumber = new Text(group, SWT.BORDER);
		workTelephoneNumber.setBounds(500, 170, 243, 20);
		menu = new Menu(shell);
		shell.setMenu(menu);
		noAnswer = new MenuItem(menu, SWT.NONE);
		noAnswer.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("No answer selected");
			}
		});
		noAnswer.setText("No answer");
		wrongNumber = new MenuItem(menu, SWT.NONE);
		wrongNumber.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("Wrong number selected");
			}
		});
		wrongNumber.setText("Wrong number");
		clientDeclined = new MenuItem(menu, SWT.NONE);
		clientDeclined.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("Client declined selected");
			}
		});
		clientDeclined.setText("Client declined");
		diarize = new MenuItem(menu, SWT.NONE);
		diarize.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("Diarize selected");
			}
		});
		diarize.setText("Diarize");
		bookAppointment = new MenuItem(menu, SWT.NONE);
		bookAppointment.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("Book appointment selected");
			}
		});
		bookAppointment.setText("Book appointment");
		updateDetails = new MenuItem(menu, SWT.NONE);
		updateDetails.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.debug("Update details selected");
			}
		});
		updateDetails.setText("Update details");
		doActions();
	}
	
	private void doActions() {
		java.util.List subs = SuburbServiceManager.getInstance().getSuburbList();
		for (Iterator iter =subs.iterator(); iter.hasNext();) {
			SuburbTO s =  (SuburbTO) iter.next();
			suburb.add(s.getSuburbName());
		}
	}

	public void dispose() {
		shell.dispose();
	}
}
