package za.co.momentum.recurring.nurse.client.ui.components;

import java.sql.Timestamp;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import za.co.momentum.recurring.base.Util;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import com.swtdesigner.SWTResourceManager;

public class AppointmentDetails extends Composite {
	private Text newComments;
	private Text lcDate;
	private Text lcUser;
	private Label lastChangeUserLabel;
	private Text comments;
	private Text additionalRequirements;
	private List testsToBeDone;
	private Text broker;
	private Text diaryCoordinator;
	private Text nurse;
	private Text appointmentDateTime;
	private Text appointmentLocation;
	private Text surname;
	private Text name;
	private Text cellNumber;
	private Text workTelephoneNumber;
	private Text homeTelephoneNumber;
	private Text addressLine2;
	private Text addressLine1;
	private Text idNumber;
	private Text language;
	private int width;
	private AppDetailTO appreq;
	private boolean detailsChanged = false;

	public AppointmentDetails(Composite parent, int style) {
		super(parent, style);
		setLayout(new FillLayout());
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				width = getSize().x - 10;
				updateControls();
			}
		});
		final TabFolder tabFolder = new TabFolder(this, SWT.NONE);
		final TabItem clientDetailsTabItem = new TabItem(tabFolder, SWT.NONE);
		clientDetailsTabItem.setText("Client details");
		final Composite clientDetails = new Composite(tabFolder, SWT.NONE);
		clientDetailsTabItem.setControl(clientDetails);
		final Label languageLabel = new Label(clientDetails, SWT.NONE);
		languageLabel.setBounds(10, 60, 55, 15);
		languageLabel.setText("Language:");
		language = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		language.setBackground(SWTResourceManager.getColor(255, 255, 255));
		language.setBounds(140, 60, 275, 20);
		final Label idpassportNumberLabel = new Label(clientDetails, SWT.NONE);
		idpassportNumberLabel.setBounds(10, 85, 100, 15);
		idpassportNumberLabel.setText("Id/Passport number:");
		idNumber = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		idNumber.setBackground(SWTResourceManager.getColor(255, 255, 255));
		idNumber.setBounds(140, 85, 275, 18);
		final Label preferredAddressLabel = new Label(clientDetails, SWT.NONE);
		preferredAddressLabel.setBounds(10, 110, 95, 15);
		preferredAddressLabel.setText("Preferred address:");
		addressLine1 = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		addressLine1.setBackground(SWTResourceManager.getColor(255, 255, 255));
		addressLine1.setBounds(140, 110, 275, 20);
		addressLine2 = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		addressLine2.setBackground(SWTResourceManager.getColor(255, 255, 255));
		addressLine2.setBounds(140, 130, 275, 20);
		final Label telephoneNumberLabel = new Label(clientDetails, SWT.NONE);
		telephoneNumberLabel.setBounds(10, 155, 100, 15);
		telephoneNumberLabel.setText("Telephone numbers:");
		final Label hLabel = new Label(clientDetails, SWT.NONE);
		hLabel.setBounds(115, 155, 15, 15);
		hLabel.setText("(H)");
		homeTelephoneNumber = new Text(clientDetails, SWT.BORDER);
		homeTelephoneNumber.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		homeTelephoneNumber.setBackground(SWTResourceManager
				.getColor(255, 255, 255));
		homeTelephoneNumber.setBounds(140, 155, 275, 20);
		final Label wLabel = new Label(clientDetails, SWT.NONE);
		wLabel.setBounds(115, 178, 20, 15);
		wLabel.setText("(W)");
		workTelephoneNumber = new Text(clientDetails, SWT.BORDER);
		workTelephoneNumber.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		workTelephoneNumber.setBackground(SWTResourceManager
				.getColor(255, 255, 255));
		workTelephoneNumber.setBounds(140, 178, 275, 20);
		final Label cLabel = new Label(clientDetails, SWT.NONE);
		cLabel.setBounds(115, 201, 15, 15);
		cLabel.setText("(C)");
		cellNumber = new Text(clientDetails, SWT.BORDER);
		cellNumber.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		cellNumber.setBackground(SWTResourceManager.getColor(255, 255, 255));
		cellNumber.setBounds(140, 201, 275, 20);
		final Label nameLabel = new Label(clientDetails, SWT.NONE);
		nameLabel.setText("Name:");
		nameLabel.setBounds(10, 10, 55, 15);
		final Label surnameLabel = new Label(clientDetails, SWT.NONE);
		surnameLabel.setText("Surname:");
		surnameLabel.setBounds(10, 35, 55, 15);
		name = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		name.setBackground(SWTResourceManager.getColor(255, 255, 255));
		name.setBounds(140, 10, 275, 20);
		surname = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		surname.setBackground(SWTResourceManager.getColor(255, 255, 255));
		surname.setBounds(140, 35, 275, 20);
		lastChangeUserLabel = new Label(clientDetails, SWT.NONE);
		lastChangeUserLabel.setBounds(10, 315, 90, 15);
		lastChangeUserLabel.setText("Last change user:");
		lcUser = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		lcUser.setBackground(SWTResourceManager.getColor(255, 255, 255));
		lcUser.setBounds(140, 315, 275, 20);
		final Label lastChangeDateLabel = new Label(clientDetails, SWT.NONE);
		lastChangeDateLabel.setBounds(10, 340, 90, 15);
		lastChangeDateLabel.setText("Last change date:");
		lcDate = new Text(clientDetails, SWT.READ_ONLY | SWT.BORDER);
		lcDate.setBackground(SWTResourceManager.getColor(255, 255, 255));
		lcDate.setBounds(140, 340, 275, 20);
		final TabItem appointmentDetailsTabItem = new TabItem(tabFolder, SWT.NONE);
		appointmentDetailsTabItem.setText("Appointment details");
		final Composite AppointmentDetails = new Composite(tabFolder, SWT.NONE);
		appointmentDetailsTabItem.setControl(AppointmentDetails);
		final Label appointmentLocationLabel = new Label(AppointmentDetails,
				SWT.WRAP);
		appointmentLocationLabel.setBounds(5, 5, 96, 36);
		appointmentLocationLabel.setText("Appointment location:");
		appointmentLocation = new Text(AppointmentDetails, SWT.V_SCROLL
				| SWT.BORDER | SWT.WRAP);
		appointmentLocation.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		appointmentLocation.setBounds(140, 5, 300, 75);
		final Label appointmentDateLabel = new Label(AppointmentDetails, SWT.WRAP);
		appointmentDateLabel.setBounds(5, 82, 133, 17);
		appointmentDateLabel.setText("Appointment date && time:");
		appointmentDateTime = new Text(AppointmentDetails, SWT.READ_ONLY
				| SWT.BORDER);
		appointmentDateTime.setBackground(SWTResourceManager
				.getColor(255, 255, 255));
		appointmentDateTime.setBounds(140, 82, 300, 20);
		final Label nurseLabel = new Label(AppointmentDetails, SWT.NONE);
		nurseLabel.setBounds(5, 104, 35, 15);
		nurseLabel.setText("Nurse:");
		nurse = new Text(AppointmentDetails, SWT.READ_ONLY | SWT.BORDER);
		nurse.setBackground(SWTResourceManager.getColor(255, 255, 255));
		nurse.setBounds(140, 104, 300, 20);
		final Label diaryCoordinatorUseridLabel = new Label(AppointmentDetails,
				SWT.NONE);
		diaryCoordinatorUseridLabel.setBounds(5, 126, 90, 15);
		diaryCoordinatorUseridLabel.setText("Diary coordinator:");
		diaryCoordinator = new Text(AppointmentDetails, SWT.READ_ONLY | SWT.BORDER);
		diaryCoordinator.setBackground(SWTResourceManager.getColor(255, 255, 255));
		diaryCoordinator.setBounds(140, 126, 300, 20);
		final Label brokerNameLabel = new Label(AppointmentDetails, SWT.NONE);
		brokerNameLabel.setBounds(5, 148, 65, 15);
		brokerNameLabel.setText("Broker name:");
		broker = new Text(AppointmentDetails, SWT.READ_ONLY | SWT.BORDER);
		broker.setBackground(SWTResourceManager.getColor(255, 255, 255));
		broker.setBounds(140, 148, 300, 20);
		final Label testsToBeLabel = new Label(AppointmentDetails, SWT.NONE);
		testsToBeLabel.setBounds(5, 170, 85, 15);
		testsToBeLabel.setText("Tests to be done:");
		testsToBeDone = new List(AppointmentDetails, SWT.V_SCROLL | SWT.BORDER
				| SWT.H_SCROLL);
		testsToBeDone.setBounds(140, 170, 300, 73);
		final Label additionalRequirementsLabel = new Label(AppointmentDetails,
				SWT.WRAP);
		additionalRequirementsLabel.setBounds(5, 243, 120, 15);
		additionalRequirementsLabel.setText("Additional requirements:");
		additionalRequirements = new Text(AppointmentDetails, SWT.V_SCROLL
				| SWT.BORDER | SWT.WRAP);
		additionalRequirements.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		additionalRequirements.setBounds(140, 243, 300, 33);
		additionalRequirements.setTabs(1);
		final Label commentsLabel = new Label(AppointmentDetails, SWT.NONE);
		commentsLabel.setBounds(5, 328, 55, 15);
		commentsLabel.setText("Comments:");
		comments = new Text(AppointmentDetails, SWT.V_SCROLL | SWT.READ_ONLY
				| SWT.BORDER | SWT.WRAP);
		comments.setBackground(SWTResourceManager.getColor(255, 255, 255));
		comments.setBounds(140, 325, 300, 57);
		newComments = new Text(AppointmentDetails, SWT.V_SCROLL | SWT.MULTI
				| SWT.BORDER);
		newComments.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				detailsChanged = true;
			}
		});
		newComments.setBounds(140, 279, 300, 45);
		final Label newCommentsLabel = new Label(AppointmentDetails, SWT.NONE);
		newCommentsLabel.setText("New comments:");
		newCommentsLabel.setBounds(5, 279, 113, 15);
	}
	public boolean isDetailsChanged() {
		return detailsChanged;
	}
	public AppDetailTO getAppreq() {
		updateTempAppreqDetails();
		return appreq;
	}
	public void setAppreq(AppDetailTO appreq) {
		this.appreq = appreq;
		fillDetails();
	}
	private void updateControls() {
		newComments.setSize(width - 140, newComments.getSize().y);
		lcDate.setSize(width - 140, lcDate.getSize().y);
		lcUser.setSize(width - 140, lcUser.getSize().y);
		comments.setSize(width - 140, comments.getSize().y);
		additionalRequirements.setSize(width - 140, additionalRequirements
				.getSize().y);
		testsToBeDone.setSize(width - 140, testsToBeDone.getSize().y);
		broker.setSize(width - 140, broker.getSize().y);
		diaryCoordinator.setSize(width - 140, diaryCoordinator.getSize().y);
		nurse.setSize(width - 140, nurse.getSize().y);
		appointmentDateTime.setSize(width - 140, appointmentDateTime.getSize().y);
		appointmentLocation.setSize(width - 140, appointmentLocation.getSize().y);
		surname.setSize(width - 140, surname.getSize().y);
		name.setSize(width - 140, name.getSize().y);
		cellNumber.setSize(width - 140, cellNumber.getSize().y);
		workTelephoneNumber.setSize(width - 140, workTelephoneNumber.getSize().y);
		homeTelephoneNumber.setSize(width - 140, homeTelephoneNumber.getSize().y);
		addressLine2.setSize(width - 140, addressLine2.getSize().y);
		addressLine1.setSize(width - 140, addressLine1.getSize().y);
		idNumber.setSize(width - 140, idNumber.getSize().y);
		language.setSize(width - 140, language.getSize().y);
	}
	private void fillDetails() {
		name.setText(appreq.getContactPerson().getFirstName() == null ? "" : appreq
				.getContactPerson().getFirstName());
		surname.setText(appreq.getContactPerson().getSurname() == null ? ""
				: appreq.getContactPerson().getSurname());
		try {
			nurse.setText(appreq.getOriginator().getLastNurse().getUser()
					.getFirstName()
					+ " " + appreq.getOriginator().getLastNurse().getUser().getSurname());
		} catch (Exception e) {
			nurse.setText("");
		}
		try {
			diaryCoordinator.setText(appreq.getOriginator().getDc().getUser()
					.getFirstName()
					+ " " + appreq.getOriginator().getDc().getUser().getSurname());
		} catch (Exception e) {
			diaryCoordinator.setText("");
		}
		workTelephoneNumber.setText(appreq.getContactPerson().getContactDetails()
				.getWorkPhoneNo() == null ? "" : appreq.getContactPerson()
				.getContactDetails().getWorkPhoneNo());
		homeTelephoneNumber.setText(appreq.getContactPerson().getContactDetails()
				.getHomePhoneNo() == null ? "" : appreq.getContactPerson()
				.getContactDetails().getHomePhoneNo());
		cellNumber.setText(appreq.getContactPerson().getContactDetails()
				.getCellNo() == null ? "" : appreq.getContactPerson()
				.getContactDetails().getCellNo());
		appointmentLocation.setText(appreq.getLocation() == null ? "" : appreq
				.getLocation());
		comments.setText(appreq.getComments() == null ? "" : appreq.getComments());
		additionalRequirements.setText(appreq.getExtraRequirements() == null ? ""
				: appreq.getExtraRequirements());
		broker.setText(appreq.getBroker());
		appointmentDateTime.setText(appreq.getStartTimeStamp() == 0 ? "" : Util
				.getStringFromTimestamp(new Timestamp(appreq.getStartTimeStamp())));
		addressLine1.setText(appreq.getAddress() == null ? "" : appreq.getAddress()
				.getLine1());
		addressLine2.setText(appreq.getAddress() == null ? "" : appreq.getAddress()
				.getLine2());
		idNumber.setText(appreq.getContactPerson().getIdNumber() == null ? ""
				: appreq.getContactPerson().getIdNumber());
		language.setText(appreq.getContactPerson().getLanguage() == null ? ""
				: appreq.getContactPerson().getLanguage());
		testsToBeDone.removeAll();
		// AppReqRequirementTO[] requirements = appreq.getRequirements();
		// if (requirements != null) {
		// HashMap hmap = new HashMap();
		// // Adding requirements to hashmap with key=grouping and object
		// // returned
		// // a
		// // list
		// for (int i = 0; i < requirements.length; i++) {
		// String key = null;
		// String value = null;
		// String description = null;
		// try {
		// key = requirements[i].getDesc().substring(0,
		// requirements[i].getDesc().indexOf("|"));
		// value = requirements[i].getDesc().substring(
		// requirements[i].getDesc().indexOf("|") + 1);
		// } catch (Exception e) {
		// // No grouping
		// key = "No group";
		// value = requirements[i].getDesc();
		// }
		// ArrayList l = (ArrayList) hmap.get(key);
		// if (l == null) {
		// // List does not exist yet, create it
		// l = new ArrayList();
		// l.add(value);
		// } else {
		// l.add(value);
		// }
		// hmap.put(key, l);
		// }
		// for (Iterator iter = hmap.keySet().iterator(); iter.hasNext();) {
		// String key = (String) iter.next();
		// ArrayList el = (ArrayList) hmap.get(key);
		// testsToBeDone.add(key);
		// for (Iterator iterator = el.iterator(); iterator.hasNext();) {
		// String element = (String) iterator.next();
		// String value = element.substring(0, element.lastIndexOf("|"));
		// String description = null;
		// if (element.lastIndexOf("|") == element.length()) {
		// description = "";
		// } else {
		// description = element.substring(element.lastIndexOf("|") + 1);
		// }
		// testsToBeDone.add(" " + value);
		// if (!description.equals("")) {
		// testsToBeDone.add(" **" + description);
		// }
		// }
		// }
		// }
		try {
			// lcDate.setText(Util.getStringFromTimestamp(new Timestamp(appreq
			// .get())));
			lcUser.setText(appreq.getOriginator().getUser().getFirstName() + " "
					+ appreq.getOriginator().getUser().getSurname());
		} catch (Exception ex) {
			lcDate.setText("");
			lcUser.setText("");
		}
		newComments.setText("");
		detailsChanged = false;
	}
	public void updateTempAppreqDetails() {
		if (comments.getText() == null) {
			appreq.setComments(comments.getText() + newComments.getText());
		} else {
			appreq.setComments(comments.getText() + "\n" + newComments.getText());
		}
		appreq.getContactPerson().getContactDetails().setHomePhoneNo(
				homeTelephoneNumber.getText());
		appreq.getContactPerson().getContactDetails().setWorkPhoneNo(
				workTelephoneNumber.getText());
		appreq.getContactPerson().getContactDetails().setCellNo(
				cellNumber.getText());
		appreq.setLocation(appointmentLocation.getText());
		appreq.setExtraRequirements(additionalRequirements.getText());
	}
}
