package za.co.momentum.recurring.nurse.client.ui.components.calendar;

import java.awt.Color;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import com.swtdesigner.SWTResourceManager;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.DayTimeslotCalendar;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.Timeslot;

public class Test {
	protected Shell shell;

	SimpleDateFormat sim = new SimpleDateFormat("yyyy/mm/dd HH:mm");

	public static void main(String[] args) {
		try {
			Test window = new Test();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void open() {
		final Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	protected void createContents() {
		shell = new Shell();
		shell.setSize(500, 375);
		shell.setText("SWT Application");

		final DayTimeslotCalendar dayTimeslotCalendar = new DayTimeslotCalendar(
				shell, SWT.NONE);
		
	
		dayTimeslotCalendar.setFont(SWTResourceManager
				.getFont("", 10, SWT.BOLD));

		dayTimeslotCalendar.setEndHour(20);
		dayTimeslotCalendar.setTimeslotHeight(120);

		dayTimeslotCalendar.setHeader("Header for calendar");
		dayTimeslotCalendar.setHeaderBackground(new Color(0, 128, 255));
		dayTimeslotCalendar.setHeaderFont(SWTResourceManager.getFont("", 18,
				SWT.BOLD));
		dayTimeslotCalendar.setTimeslot1BackGround(new Color(255, 255, 255));
		dayTimeslotCalendar.setTimeslot2BackGround(new Color(239, 239, 239));
		dayTimeslotCalendar.setLabel2BackGround(new Color(240, 240, 240));
		dayTimeslotCalendar.setLabel1BackGround(new Color(255, 255, 255));
		dayTimeslotCalendar.setAppointmentColor(new Color(194, 229, 255));
		dayTimeslotCalendar.setBounds(18, 10, 447, 322);
		dayTimeslotCalendar.setDefaultNewAppointmentTimeInMinutes(60);

		Calendar cal = Calendar.getInstance();
		Calendar cal2 = Calendar.getInstance();
		cal2.add(Calendar.HOUR, 1);
		Calendar cal3 = Calendar.getInstance();
		cal3.add(Calendar.MINUTE, 10);
		Calendar cal4 = Calendar.getInstance();
		cal4.add(Calendar.MINUTE, 50);
		Calendar cal5 = Calendar.getInstance();
		cal5.add(Calendar.DAY_OF_YEAR, -5);

		RealAppointment app = new RealAppointment();
		app.setDes("My appointment");
		app.setStartTime(cal3);
		app.setEndTime(cal4);

		dayTimeslotCalendar.setDate(cal5);
		System.out.println("Calendar date="
				+ new SimpleDateFormat("yyyy/MM/dd").format(dayTimeslotCalendar
						.getDate().getTime()));
		System.out.println("Appointment date="
				+ new SimpleDateFormat("yyyy/MM/dd").format(cal3.getTime()));
		dayTimeslotCalendar.addAppointment(app);
		dayTimeslotCalendar
				.addAppointmentSelectListener(new AppointmentSelectedListener() {
					public void appointmentSelectedEvent(MouseEvent e) {
						System.out.println("Mouse button = " + e.button);
						System.out.println("Appointment selected "
								+ dayTimeslotCalendar.getSelectedAppointment()
										.getDescription());

					}

				

				});
		dayTimeslotCalendar
				.addDateChangedListener(new SelectedDateChangedListener() {

					public void changeEvent() {
						Calendar temp = dayTimeslotCalendar.getSelectedDate();
						Calendar start = Calendar.getInstance();
						start.setTime(temp.getTime());
						RealAppointment app = new RealAppointment();
						app.setDes("My temp appointment");
						app.setStartTime(start);
						System.out.println("Date selected begin="
								+ new SimpleDateFormat("yyyy/MM/dd hh:mm")
										.format(temp.getTime()));
						temp.add(Calendar.MINUTE, dayTimeslotCalendar
								.getDefaultNewAppointmentTimeInMinutes());
						app.setEndTime(temp);
						System.out.println("Date selected end="
								+ new SimpleDateFormat("yyyy/MM/dd hh:mm")
										.format(temp.getTime()));
						dayTimeslotCalendar.removeTempAppointment();
						dayTimeslotCalendar.addTempAppointment(app);
					}

				});

		dayTimeslotCalendar.setDate(cal);
		dayTimeslotCalendar.addAppointment(app);

	}
}
