package za.co.momentum.recurring.nurse.client.ui.wizards;

import java.util.Calendar;
import org.apache.log4j.Logger;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.nurse.client.ui.SWTCalendar;
import za.co.momentum.recurring.nurse.client.ui.SWTCalendarEvent;
import za.co.momentum.recurring.nurse.client.ui.SWTCalendarListener;

public class RescheduleAppointmentWizzardPage1 extends TitleAreaDialog {
	private static final Logger LOG = Logger
			.getLogger(RescheduleAppointmentWizzardPage1.class);
	private SWTCalendar calendar;
	private Calendar selectedDate = Calendar.getInstance();
	private Button nextButton;

	public Calendar getSelectedDate() {
		return selectedDate;
	}
	public RescheduleAppointmentWizzardPage1(Shell parentShell) {
		super(parentShell);
	}
	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		final Label selectPreferredDateLabel = new Label(container, SWT.NONE);
		selectPreferredDateLabel.setBounds(5, 5, 150, 15);
		selectPreferredDateLabel.setText("Select preferred date");
		calendar = new SWTCalendar(container, SWT.NONE);
		calendar.addSWTCalendarListener(new SWTCalendarListener() {
			public void dateChanged(SWTCalendarEvent e) {
				validateInput();
			}
		});
		calendar.setBounds(45, 38, 180, 150);
		setTitle("Reschedule appointment");
		setMessage("Please select a new date");
		return area;
	}
	private boolean validateInput() {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.HOUR, 0);
		if ((cal.getTimeInMillis() <= calendar.getCalendar().getTimeInMillis())) {
			setErrorMessage(null);
			selectedDate = calendar.getCalendar();
			nextButton.setEnabled(true);
			return true;
		} else {
			setErrorMessage("Date selected must be in the future");
			nextButton.setEnabled(false);
			return false;
		}
	}
	protected void buttonPressed(int buttonId) {
		setReturnCode(buttonId);
		close();
	}
	protected void createButtonsForButtonBar(Composite parent) {
		nextButton = createButton(parent, IDialogConstants.NEXT_ID,
				IDialogConstants.NEXT_LABEL, true);
		createButton(parent, IDialogConstants.CANCEL_ID,
				IDialogConstants.CANCEL_LABEL, false);
	}
	protected Point getInitialSize() {
		return new Point(279, 333);
	}
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText(Application.APPLICATION_NAME);
	}
}
