package za.co.momentum.recurring.nurse.client.ui.wizards;

import java.awt.Color;
import java.util.Calendar;

import org.apache.log4j.Logger;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Text;

import za.co.momentum.recurring.base.Util;
import za.co.momentum.recurring.client.TNPlugin.Application;
import za.co.momentum.recurring.nurse.client.sao.appreq.AppReqServiceManager;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.AppReqAppointment;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.Appointment;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.AppointmentSelectedListener;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.DayTimeslotCalendar;
import za.co.momentum.recurring.nurse.client.ui.components.calendar.SelectedDateChangedListener;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import za.co.momentum.risk.fastlane.nurse.dto.RoleTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import za.co.momentum.recurring.nurse.util.ClientProperties;

import com.swtdesigner.SWTResourceManager;

public class RescheduleAppointmentWizzardPage2 extends TitleAreaDialog {
	private Text dateWithoutminutes;

	private Text selectedNurse;

	private static final Logger LOG = Logger
			.getLogger(RescheduleAppointmentWizzardPage2.class);

	private Calendar date;

	private Button finishButton;

	private DayTimeslotCalendar dayTimeslotCalendar;

	private UserTO user;

	private RoleTO nurse;

	private Calendar timeslotSelected;

	private int duration;

	private Spinner durationSpinner;

	private String appointmentForPerson;

	private boolean AppointmentIsOverlapping;

	private int previousDuration;

	public int getDuration() {
		return duration;
	}

	public void setUser(UserTO user) {
		this.user = user;
	}

	public void setNurse(RoleTO nurse) {
		this.nurse = nurse;
	}

	public Calendar getTimeslotSelected() {
		return timeslotSelected;
	}

	public RescheduleAppointmentWizzardPage2(Shell parentShell, Calendar date,
			int prevDuration) {
		super(parentShell);
		this.date = date;
		previousDuration = prevDuration;
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayout(new FillLayout());
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		final ScrolledComposite scrolledComposite = new ScrolledComposite(
				container, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		final Composite composite = new Composite(scrolledComposite, SWT.NONE);
		composite.setLocation(0, 0);
		int xplace = 0;
		dayTimeslotCalendar = new DayTimeslotCalendar(composite, SWT.NONE);
		dayTimeslotCalendar.setStartHour(Integer.parseInt(ClientProperties
				.getInstance().getProperty("calendar.start.hour")));
		dayTimeslotCalendar.setEndHour(Integer.parseInt(ClientProperties
				.getInstance().getProperty("calendar.end.hour")));
		dayTimeslotCalendar.setTimeslotLengthInMinutes(15);
		dayTimeslotCalendar.setSnapToTime(15);
		dayTimeslotCalendar.setHeader(user.getFirstName() + " "
				+ user.getSurname());
		dayTimeslotCalendar.setAppointmentColor(new Color(255, 128, 255));
		dayTimeslotCalendar.setTimeslotHeight(60);
		dayTimeslotCalendar.setLabelLength(35);
		dayTimeslotCalendar.setHeaderBackground(new Color(0, 128, 255));
		dayTimeslotCalendar.setHeaderFont(SWTResourceManager.getFont("", 18,
				SWT.BOLD));
		dayTimeslotCalendar.setTimeslot1BackGround(new Color(255, 255, 255));
		dayTimeslotCalendar.setTimeslot2BackGround(new Color(239, 239, 239));
		dayTimeslotCalendar.setLabel2BackGround(new Color(240, 240, 240));
		dayTimeslotCalendar.setLabel1BackGround(new Color(255, 255, 255));
		dayTimeslotCalendar.setAppointmentColor(new Color(194, 229, 255));
		dayTimeslotCalendar.setBounds(xplace, 0, 250, 272);
		dayTimeslotCalendar
				.setDefaultNewAppointmentTimeInMinutes(previousDuration);
		dayTimeslotCalendar.setDate(date);
		dayTimeslotCalendar
				.addAppointmentSelectListener(new AppointmentSelectedListener() {
					public void appointmentSelectedEvent(MouseEvent e) {
						LOG.info("Appointment selected "
								+ dayTimeslotCalendar.getSelectedAppointment()
										.getDescription());
						dateWithoutminutes.setText("");
						selectedNurse.setText("");
						durationSpinner.setEnabled(false);
						validateInput();
					}
				});
		dayTimeslotCalendar
				.addDateChangedListener(new SelectedDateChangedListener() {
					public void changeEvent() {
						AppDetailTO appreq = new AppDetailTO();
						appreq.setStartTimeStamp(dayTimeslotCalendar
								.getSelectedDate().getTimeInMillis());
						Calendar cal = Calendar.getInstance();
						cal.setTime(dayTimeslotCalendar.getSelectedDate()
								.getTime());
						cal.add(Calendar.MINUTE, dayTimeslotCalendar
								.getDefaultNewAppointmentTimeInMinutes());
						appreq.setEndTimeStamp(cal.getTimeInMillis());
						Appointment temp = new AppReqAppointment(appreq);
						dayTimeslotCalendar.removeTempAppointment();
						temp.setDescription("New Appointment timeslot");
						dayTimeslotCalendar.addTempAppointment(temp);
						dateWithoutminutes.setText(Util
								.formatDateToDateTime(dayTimeslotCalendar
										.getSelectedAppointment()
										.getStartTime().getTime()));
						timeslotSelected = dayTimeslotCalendar
								.getSelectedAppointment().getStartTime();
						selectedNurse.setText(dayTimeslotCalendar.getHeader());
						durationSpinner.setEnabled(true);
						AppointmentIsOverlapping = dayTimeslotCalendar
								.isTempAppointmentIsOverlapping();
						validateInput();
					}
				});
		xplace += 250;
		durationSpinner = new Spinner(composite, SWT.BORDER);
		durationSpinner.setEnabled(false);
		durationSpinner.setSelection(previousDuration);
		durationSpinner.setMaximum(120);
		durationSpinner.setMinimum(5);
		durationSpinner.setBounds(442, 276, 55, 25);
		durationSpinner.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				LOG.info("Duration changed");
				dayTimeslotCalendar
						.setDefaultNewAppointmentTimeInMinutes(durationSpinner
								.getSelection());
				duration = durationSpinner.getSelection();
				AppointmentIsOverlapping = dayTimeslotCalendar
						.isTempAppointmentIsOverlapping();
				updateTempAppointment();
			}
		});
		durationSpinner.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				LOG.info("Duration changed");
				dayTimeslotCalendar
						.setDefaultNewAppointmentTimeInMinutes(durationSpinner
								.getSelection());
				duration = durationSpinner.getSelection();
				AppointmentIsOverlapping = dayTimeslotCalendar
						.isTempAppointmentIsOverlapping();
				updateTempAppointment();
			}
		});
		selectedNurse = new Text(composite, SWT.BORDER);
		selectedNurse.setEditable(false);
		selectedNurse.setBounds(106, 305, 207, 25);
		final Label selectedNurseLabel = new Label(composite, SWT.NONE);
		selectedNurseLabel.setText("Selected nurse");
		selectedNurseLabel.setBounds(4, 309, 75, 15);
		final Label selectedTimeslotLabel = new Label(composite, SWT.NONE);
		selectedTimeslotLabel.setText("Selected timeslot");
		selectedTimeslotLabel.setBounds(4, 279, 85, 15);
		dateWithoutminutes = new Text(composite, SWT.BORDER);
		dateWithoutminutes.setEditable(false);
		dateWithoutminutes.setBounds(106, 276, 207, 25);
		final Label durationLabel = new Label(composite, SWT.NONE);
		durationLabel.setText("Duration");
		durationLabel.setBounds(395, 285, 45, 15);
		composite.setSize(510, 342);
		scrolledComposite.setContent(composite);
		//
		// doActions();
		setTitle("Reschedule appointment for " + appointmentForPerson);
		setMessage("Please select timeslot");
		addAppointments();
		return area;
	}

	private void updateTempAppointment() {
		dayTimeslotCalendar.removeTempAppointment();
		AppDetailTO appreq = new AppDetailTO();
		appreq.setStartTimeStamp(dayTimeslotCalendar.getSelectedDate()
				.getTimeInMillis());
		Calendar cal = Calendar.getInstance();
		cal.setTime(dayTimeslotCalendar.getSelectedDate().getTime());
		cal.add(Calendar.MINUTE, dayTimeslotCalendar
				.getDefaultNewAppointmentTimeInMinutes());
		appreq.setEndTimeStamp(cal.getTimeInMillis());
		appreq.setComments("Temporary appointment");
		Appointment temp = new AppReqAppointment(appreq);
		temp.setDescription("New appointment timeslot");
		dayTimeslotCalendar.removeTempAppointment();
		dayTimeslotCalendar.addTempAppointment(temp);
		dateWithoutminutes.setText(Util
				.formatDateToDateTime(dayTimeslotCalendar
						.getSelectedAppointment().getStartTime().getTime()));
		validateInput();
	}

	private void addAppointments() {
		AppDetailTO[] appreqs = null;
		LOG.info("Getting appreqs for nurse id " + user.getId());
		appreqs = AppReqServiceManager.getInstance().getAppreqsByDate(nurse,
				date);
		if (appreqs != null) {
			LOG.info("Got appreqs for nurse id " + user.getId() + " size is "
					+ appreqs.length);
			for (int j = 0; j < appreqs.length; j++) {
				Appointment app = new AppReqAppointment(appreqs[j]);
				if (appreqs[j].getContactPerson() != null) {
					app.setDescription(appreqs[j].getContactPerson()
							.getFirstName()
							+ " " + appreqs[j].getContactPerson().getSurname());
				} else {
					app.setDescription("Personal Appointment");
				}
				dayTimeslotCalendar.addAppointment(app);
			}
		}
	}

	private void doActions() {
		addAppointments();
	}

	protected void buttonPressed(int buttonId) {
		setReturnCode(buttonId);
		close();
	}

	private boolean validateInput() {
		if (timeslotSelected.getTimeInMillis() < Calendar.getInstance()
				.getTimeInMillis()) {
			setErrorMessage("Timeslot selected must be in the future!");
			finishButton.setEnabled(false);
			return false;
		}
		if (nurse == null || timeslotSelected == null) {
			setErrorMessage("Please select timeslot and nurse");
			finishButton.setEnabled(false);
			return false;
		}
		if (AppointmentIsOverlapping) {
			setErrorMessage("Selected timeslot is overlapping with another appointment.  Please select another timeslot or change the appointment duration.");
			finishButton.setEnabled(false);
			dayTimeslotCalendar.removeTempAppointment();
			return false;
		}
		setErrorMessage(null);
		duration = durationSpinner.getSelection();
		finishButton.setEnabled(true);
		setMessage(null);
		return true;
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.BACK_ID,
				IDialogConstants.BACK_LABEL, false);
		finishButton = createButton(parent, IDialogConstants.FINISH_ID,
				IDialogConstants.FINISH_LABEL, true);
		finishButton.setEnabled(false);
		createButton(parent, IDialogConstants.CANCEL_ID,
				IDialogConstants.CANCEL_LABEL, false);
	}

	protected Point getInitialSize() {
		return new Point(523, 491);
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText(Application.APPLICATION_NAME);
	}

	public void setAppointmentForPerson(String appointmentForPerson) {
		this.appointmentForPerson = appointmentForPerson;
	}
}
