package za.co.momentum.recurring.nurse.util;

import java.io.IOException;
import java.net.URL;
import java.util.Properties;
import za.co.momentum.recurring.exceptions.DomainRuntimeException;

public class ClientProperties {
	// private static final String PROPERTY_FILENAME = "." + File.separator
	// + Platform.getProduct().getDefiningBundle().getLocation()
	// .substring(
	// Platform.getProduct().getDefiningBundle().getLocation().indexOf(
	// "@") + 1) + "client.properties";
	private static URL PROPERTY_FILENAME;
	private static ClientProperties singleton;
	private static Properties properties;
	/*
	 * Define the constant resources here.
	 */
	public static final String CLIENT_RESOURCES = "client.resourcepath";
	public static final String PDF_EDITOR_PATH = "client.pdfeditorpath";
	public static final String FTP_SERVER_NAME = "ftp.server.name";
	public static final String FTP_SERVER_USERNAME = "ftp.server.username";
	public static final String FTP_SERVER_PASSWORD = "ftp.server.password";
	public static final String CLIENT_TIMEOUT = "client.timeout";
	public static final String FILE_SUBURB = "file.suburb";
	public static final String CALENDAR_START_HOUR = "calendar.start.hour";
	public static final String CALENDAR_END_HOUR = "calendar.end.hour";
	public static final String FTP_PATH = "ftp.server.resourcePath";
	public static final String PDF_SOURCE_DIRECTORY = "client.pdfsourcedir";
	public static final String PDF_SAVE_DIRECTORY = "client.pdfsavedir";
	public static final String PDF_SENT_DIRECTORY = "client.pdfsentdir";
	public static final String AFRIKAANS = "client.afrikaans";
	public static final String ENGLISH = "client.english";
	public static final String AFRIKAANS_DIR = "client.afrikaansdir";
	public static final String ENGLISH_DIR = "client.englishdir";
	public static final String PDF_RESOURCES = "TNResources";
	public static final String PDF_FILE_NAME_CODE = "client.pdfnamecode";
	public static final String PDF_FILE_NAME_LENGTH = "client.pdfnamelength";
	public static final String UPDATE_URL = "client.update.path";
  public static final String ECG_DIRECTORY = "client.pdfecgdir";
  public static final String EFORM_BACKUP_DIRECTORY = "client.eformbackupdir";
  

	private ClientProperties() {
		URL url = this.getClass().getResource("/client.properties");
		PROPERTY_FILENAME = url;
	}

	public static ClientProperties getInstance() {
		synchronized (ClientProperties.class) {
			if (singleton == null) {
				singleton = new ClientProperties();
				properties = new Properties();
				try {
					properties.load(PROPERTY_FILENAME.openStream());
				} catch (IOException e) {
					// 
					e.printStackTrace();
				}
			}
		}
		return singleton;
	}

	public boolean isTestEnvironment() {
		if ("true".equalsIgnoreCase(getProperty("environment.test")))
			return true;
		else
			return false;
	}

	public String getProperty(String key) {
		Properties props = getSystemProperties();
		String prop = props.getProperty(key);
		if (prop == null)
			throw new DomainRuntimeException("System Property not found: " + key);
		// LOG.debug("Query System Property: " + key + " = " + prop);
		return prop;
	}

	public Properties getSystemProperties() {
		if (properties == null)
			throw new DomainRuntimeException("System Properties not loaded");
		if (properties.size() == 0)
			throw new DomainRuntimeException("No System Properties available");
		return properties;
	}
}
