package za.co.momentum.recurring.nurse.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;

import za.co.momentum.recurring.nurse.client.model.ClientSecurityManager;
import za.co.momentum.recurring.nurse.client.model.ClientWindowManager;
import za.co.momentum.recurring.nurse.client.tools.PdfFileManager;
import za.co.momentum.recurring.nurse.client.ui.ProgressDialog;
import za.co.momentum.risk.fastlane.nurse.dto.AppClientTO;
import za.co.momentum.risk.fastlane.nurse.dto.AppDetailTO;
import za.co.momentum.risk.fastlane.nurse.dto.RequirementTO;
import za.co.momentum.risk.fastlane.nurse.dto.UserTO;
import za.co.momentum.risk.fastlane.nurse.eforms.BaseForm;

public class WebCaller implements Runnable {
  private static WebCaller instance;

  public static WebCaller getIntance() {
    if (instance == null) {
      instance = new WebCaller();
    }
    return instance;
  }

  private HashMap callsToMake;

  private boolean stop;

  private Long hashmapKey;

  private WebCaller() {
    callsToMake = new HashMap();
    stop = false;
    hashmapKey = new Long(1);
  }

  public Map getCalls() {
    return callsToMake;
  }

  public void start() {
    stop = false;
    run();
  }

  public void stop() {
    stop = true;
  }

  public void addWebCall(WebCall wc) {
    callsToMake.put(hashmapKey, wc);
    hashmapKey = new Long(hashmapKey.longValue() + 1);
  }

  public void run() {
    while (!stop) {
      try {
        Collection remove = new ArrayList();
        // TNLogger
        // .debug("Webcaller checking if it has actions to perform size
        // of map="
        // + callsToMake.size());
        for (Iterator iter = callsToMake.keySet().iterator(); iter.hasNext();) {
          Long key = (Long) iter.next();
          WebCall el = (WebCall) callsToMake.get(key);
          if ((el == null || el.getStatus() == WebCall.STATUS_DONE)
              && (el.getDescription().indexOf("Appointment done") == -1)) {
            // replace this removed for testing purposes
            remove.add(key);
          }
        }
        callsToMake.keySet().removeAll(remove);
        Map add = new HashMap();
        for (Iterator iter = callsToMake.keySet().iterator(); iter.hasNext();) {
          Long key = (Long) iter.next();
          WebCall el = (WebCall) callsToMake.get(key);
          if (el == null)
            continue;
          if ((el.getStatus() != WebCall.STATUS_ERROR && el.getStatus() != WebCall.STATUS_DONE)
              || (el.getRetries() == 0 && el.getStatus() != WebCall.STATUS_DONE)
              || (el.getRetryCount() < el.getRetries() && el.getStatus() != WebCall.STATUS_DONE)) {
            TNLogger.debug("Webcaller executing a action retry count= " + el.getRetryCount() + " status = "
                + el.getStatus());
            el.run();
            if (el.getDescription().indexOf("Appointment done") != -1) {
              if (el.getStatus() == WebCall.STATUS_DONE) {
                final String descr = el.getDescription();
                Display.getDefault().syncExec(new Runnable() {
                  public void run() {
                    try {
                      ProgressDialog progDialog = new ProgressDialog(ClientWindowManager.getInstance().getShell(),
                          SWT.NULL);
                      progDialog.setMessage(descr);
                      progDialog.open();

                    } catch (Exception e) {
                      TNLogger.error(e.getMessage());
                    }
                  }
                });
              }
            }
            add.put(key, el);
            // do something with returnObject
            if (el.getReturnObject() instanceof BaseForm) {
              addToEFormDB((BaseForm) el.getReturnObject(), el.getRefno());
            }
            if (el.getReturnObject() instanceof AppDetailTO) {
              addToAppReqDB((AppDetailTO) el.getReturnObject());
              AppDetailTO appDetTO = (AppDetailTO) el.getReturnObject();
              for (int i = 0; i < appDetTO.getClients().length; i++) {
                //copyPdfsToSent(appDetTO.getClients()[i]);
                
                backupAllEformsForClient(appDetTO.getClients()[i]);
              }
            }
            if (el.getReturnObject() instanceof UserTO) {
              addToUserDB((UserTO) el.getReturnObject());
            }
            if (el.getStatus() == 4) {
              el.getReturnObject();
            }
            if (el.getStatus() == 5) { // timeout
              TNLogger.debug("Timeout " + el.getDescription());
            }
          }
        }
        callsToMake.putAll(add);
        try {
          // TODO - Webcaller cycle length
          Thread.sleep(120000);
        } catch (InterruptedException e) {
          TNLogger.error("WebCaller Thread interupted " + e.getMessage());
        }
      } catch (Exception e) {
        TNLogger.error("Something gone wrong " + e.getMessage());
      }
    }
  }

  private boolean addToEFormDB(BaseForm form, long id) {
    return DBHelper.AddEForm(form, id);
  }

  private boolean addToUserDB(UserTO user) {
    return DBHelper.addUser(user);
  }

  private boolean addToAppReqDB(AppDetailTO appreq) {
    return DBHelper.AddAppReq(appreq, ClientSecurityManager.getInstance().getUser().getUsername());
  }

  /**
   * When the pdfs has been sent the files are copied to the SENT directory using this method
   * 
   */
  private void copyPdfsToSent(AppClientTO client) {
    RequirementTO[] reqs = client.getRequirements();
    for (int i = 0; i < reqs.length; i++) {
      //PdfFileManager.copyFileToSent(client.getClientNumber(), getFormNo(reqs[i].getFormNo()));
    }
  }

  private void backupAllEformsForClient(AppClientTO appClientTO) {
    String clientName = appClientTO.getPerson().getFirstName() + " " + appClientTO.getPerson().getSurname();
    PdfFileManager.backupAllFilesForClientNumber(appClientTO.getPolicyAlpha(), appClientTO.getPolicyNumber(),
        clientName, appClientTO.getClientNumber());
  }

  private String getFormNo(String formName) {
    return PdfFileManager.getFormNo(formName);
  }
}
