package za.co.momentum.recurring.nurse.util.anttasks;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.StringTokenizer;
import org.apache.tools.ant.BuildException;


public class WebServiceParameter extends org.apache.tools.ant.Task{
	
	public static void main(String[] args) {
		System.out.println("Start");
		WebServiceParameter test = new WebServiceParameter();
		test.setServiceLocaterFiles("C:/UserServiceServiceLocator.java");
		test.setParameterNames("WebServiceUrl.user");
		test.execute();
		
		System.out.println("End");
	}
	
	
	//Semicolon delimited string of files to change to parameters
	private String serviceLocaterFiles;
	
	//Semicolon delimited string of paramter name that corresponds to file that must be parameterized
	private String parameterNames;
	
	
	public String getParameterNames() {
		return parameterNames;
	}

	public void setParameterNames(String parameterNames) {
		this.parameterNames = parameterNames;
	}

	public String getServiceLocaterFiles() {
		return serviceLocaterFiles;
	}

	public void setServiceLocaterFiles(String serviceLocaterFiles) {
		this.serviceLocaterFiles = serviceLocaterFiles;
	}

	public void execute() throws BuildException  {
		StringTokenizer st = new StringTokenizer(serviceLocaterFiles, ";");
		StringTokenizer params = new StringTokenizer(parameterNames, ";");
		if (st.countTokens() != params.countTokens()) {
			throw new BuildException("Service locater files count must be equal to paramter names");
		}
		while (st.hasMoreTokens()) {
			String filename = st.nextToken();
			String param = params.nextToken();
			BufferedWriter outFile = null;
			BufferedReader f1 = null;
			try {
				f1 = new BufferedReader(new FileReader(filename));
				outFile = new BufferedWriter(new FileWriter(filename+"tmp"));
				while (f1.ready()) {
					String temp = f1.readLine();
					if (temp.indexOf("http://") > 0) {
						//System.out.println("Found the line and it is =" + temp);
						String firstPart = temp.substring(0, temp.indexOf("="));
						firstPart += "= za.co.momentum.recurring.nurse.util.ClientProperties.getInstance().getProperty(\"" + param + "\");";
						//System.out.println("New line=" + firstPart);
						outFile.write(firstPart);
					}else {
						outFile.write(temp);
					}
					outFile.write("\n");
				}
					
				f1.close();
				outFile.flush();
				outFile.close();
				renameFiles(filename+"tmp", filename);
			} catch (IOException e) {
				System.out.println("Error " + e.getMessage());
			
			}
		}
	}
	
	private void renameFiles(String oldFile, String newFile) {
		File old = new File(oldFile);
		File f = new File(newFile);
		if (f.exists()) {
			f.renameTo(new File(f.getAbsolutePath() + Calendar.getInstance().getTimeInMillis()));
			
		}
		old.renameTo(new File(newFile));
	}
}
