package za.co.momentum.recurring.nurse.util.anttasks;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;
import org.apache.tools.ant.BuildException;

public class WsddMerger extends org.apache.tools.ant.Task {
	private String mergeFiles;
	private String outFilename;
	
	public static void main(String[] args) {
		WsddMerger merge = new WsddMerger();
		merge.setMergeFiles("c:/temp3/server-configCLIENT.wsdd;c:/temp3/server-configTEST.wsdd;c:/temp3/axis-extra.wsdd");
		merge.setOutFilename("c:/temp3/server-config.wsdd");
		merge.execute();
	}

	//Comma delimited string of files to be merged
	public void setMergeFiles(String mergeFiles) {
		this.mergeFiles = mergeFiles;
	}

	//Output file that contains merged data
	public void setOutFilename(String outFilename) {
		this.outFilename = outFilename;
	}

	public void execute() throws BuildException {
		StringTokenizer st = new StringTokenizer(mergeFiles, ";");
		
		BufferedReader f1 = null;
		BufferedWriter outFile = null;
		boolean writeFile = true;
		try {
			outFile = new BufferedWriter(new FileWriter(outFilename));
			outFile
					.write("<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\" xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">");
			outFile.write("\n");
		
			while (st.hasMoreTokens()) {
				String filename = st.nextToken();
				// Go through first file and add to outFile
				f1 = new BufferedReader(new FileReader(filename));
				String temp;
				while (f1.ready()) {
					temp = f1.readLine();
					writeFile = true;
					//Write everything to outfile except the deployment tag
					if (temp.indexOf("<deployment") >= 0) {
						writeFile = false;
						while (!writeFile) {
							temp = f1.readLine();
							if (temp.indexOf(">") >= 0) {
								writeFile = true;
							}
						}
						writeFile = false;
					}
					if (temp.indexOf("</deployment") >= 0) {
						writeFile = false;
					}
					if (writeFile) {
						outFile.write(temp);
						outFile.write("\n");
					}
				}
				f1.close();
			}
			outFile.write("\n");
			outFile.write("</deployment>");
			outFile.write("\n");
			outFile.flush();
			outFile.close();
		} catch (FileNotFoundException e) {
			throw new BuildException(e);
		} catch (IOException e) {
			throw new BuildException(e);
		}
	}
}
